| package |
package := Package name: 'SIXX-Core'.
package paxVersion: 0;
	basicComment: ''.


package classNames
	add: #SixxClassNotFound;
	add: #SixxConstants;
	add: #SixxInvalidDeserialization;
	add: #SixxInvalidSerialization;
	add: #SixxNewFailed;
	add: #SixxReadStream;
	add: #SixxSetting;
	add: #SixxWarning;
	add: #SixxWriteStream;
	add: #SixxXmlParseError;
	add: #SixxXmlUtil;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package allResourceNames: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\Object Arts\Dolphin\Base\Dolphin';
	add: 'SIXX-Dolphin';
	add: '..\Steve Waring\Yaxo\YAXO DOM';
	yourself).

package!

"Class Definitions"!

Object subclass: #SixxConstants
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: 'xmlVersion xmlEncoding sixxVersion sixxStartTag xmlDeclaration'!
Object subclass: #SixxReadStream
	instanceVariableNames: 'stream sixxElements contextDictionary position limit cachedObjects'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #SixxSetting
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: 'useCDATA useEnvironment useRecoveryRead'!
Object subclass: #SixxWriteStream
	instanceVariableNames: 'stream contextDictionary isStartTagPut isEndTagPut'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #SixxXmlUtil
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: 'convertCharDict parserAdapter'!
Error subclass: #SixxXmlParseError
	instanceVariableNames: 'originalError'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Warning subclass: #SixxWarning
	instanceVariableNames: 'className element context'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SixxWarning subclass: #SixxClassNotFound
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SixxWarning subclass: #SixxInvalidDeserialization
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SixxWarning subclass: #SixxInvalidSerialization
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SixxWarning subclass: #SixxNewFailed
	instanceVariableNames: 'alternativeInstance'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

"End of package definition"!

"Source Globals"!

"Classes"!

SixxConstants guid: (GUID fromString: '{B1C93138-8661-413D-996B-26FCD500D96F}')!
SixxConstants comment: ''!
!SixxConstants categoriesForClass!Kernel-Objects! !
!SixxConstants class methodsFor!

initialize
	xmlVersion := nil.
	xmlEncoding := nil.
	sixxVersion := nil.
	sixxStartTag := nil.
	xmlDeclaration := nil!

sixxEndTag
	^'</sixx>' copy!

sixxStartTag
	sixxStartTag isNil 
		ifTrue: [sixxStartTag := '<sixx sixx.version="' , self sixxVersion , '">'].
	^sixxStartTag!

sixxVersion
	sixxVersion isNil ifTrue: [sixxVersion := '1.0'].
	^sixxVersion!

sixxVersion: versionString
	sixxStartTag := nil.
	sixxVersion := versionString!

xmlDeclaration
	xmlDeclaration isNil 
		ifTrue: 
			[xmlDeclaration := '<?xml version="' , self xmlVersion , '" encoding="' , self xmlEncoding 
						, '"?>'].
	^xmlDeclaration!

xmlEncoding
	xmlEncoding isNil ifTrue: [xmlEncoding := 'utf-8'].
	^xmlEncoding!

xmlEncoding: encodingString
	xmlDeclaration := nil.
	xmlEncoding := encodingString!

xmlVersion
	xmlVersion isNil ifTrue: [xmlVersion := '1.0'].
	^xmlVersion!

xmlVersion: versionString
	xmlDeclaration := nil.
	xmlVersion := versionString! !
!SixxConstants class categoriesFor: #initialize!class initialization!public! !
!SixxConstants class categoriesFor: #sixxEndTag!constants!public! !
!SixxConstants class categoriesFor: #sixxStartTag!constants!public! !
!SixxConstants class categoriesFor: #sixxVersion!accessing!public! !
!SixxConstants class categoriesFor: #sixxVersion:!accessing!public! !
!SixxConstants class categoriesFor: #xmlDeclaration!constants!public! !
!SixxConstants class categoriesFor: #xmlEncoding!accessing!public! !
!SixxConstants class categoriesFor: #xmlEncoding:!accessing!public! !
!SixxConstants class categoriesFor: #xmlVersion!accessing!public! !
!SixxConstants class categoriesFor: #xmlVersion:!accessing!public! !

SixxReadStream guid: (GUID fromString: '{C1E97EA3-F909-469B-B5F3-51EB8476FFC4}')!
SixxReadStream comment: ''!
!SixxReadStream categoriesForClass!Kernel-Objects! !
!SixxReadStream methodsFor!

atEnd
	^self position >= self limit!

cachedObjects
	^cachedObjects!

checkSixxElement: sixxElement
	(SixxXmlUtil nameFrom: sixxElement) = #sixx
		ifFalse: [self error: 'unexpected element: ' , (SixxXmlUtil nameFrom: sixxElement)]!

close
	self stream close!

contents
	^(self next: self size) asArray!

contextDictionary
	^contextDictionary!

findStringIndexes: subString from: sourceString
	| foundIndexes index |
	foundIndexes := OrderedCollection new.
	index := 1.
	[index = 0] whileFalse: 
			[index := sourceString findString: subString startingAt: index.
			index = 0 
				ifFalse: 
					[foundIndexes add: index.
					index := index + 1]].
	^foundIndexes!

initialize
	contextDictionary := IdentityDictionary new.
	position := 0.
	sixxElements := self parseStream: stream.
	limit := sixxElements isNil ifTrue: [0] ifFalse: [sixxElements size].
	cachedObjects := Dictionary new!

limit
	^limit!

next
	^self atEnd 
		ifFalse: 
			[position := position + 1.
			self cachedObjects at: position
				ifAbsentPut: [self readSixxFromSixxElement: (sixxElements at: position)]]!

next: anInteger
	| ord |
	anInteger < 0 ifTrue: [^nil].
	ord := OrderedCollection new: anInteger.
	anInteger timesRepeat: [self atEnd ifFalse: [ord add: self next]].
	^ord!

on: aStream
	stream := aStream.
	self initialize!

parseStream: aStream 
	| root str recoverTried |
	(aStream isNil or: [aStream size = 0]) ifTrue: [^nil].
	str := aStream.
	recoverTried := false.
	[root := SixxXmlUtil parseXml: str]
		on: SixxXmlParseError do: [:ex | (SixxSetting useRecoveryRead and: [recoverTried not])
			ifTrue: 
				[str := self recoveredStreamFrom: str.
				recoverTried := true.
				ex retry]
			ifFalse: [ex pass]].
	self checkSixxElement: root.
	^SixxXmlUtil elementsFrom: root!

peek
	| nextObj |
	nextObj := self next.
	self privatePosition: self position - 1.
	^nextObj!

position
	^position!

position: anInteger
	(anInteger < 0 and: [anInteger > limit]) ifTrue: [self error: 'out of bounds'].
	self reset.
	self next: anInteger!

privatePosition: anInteger
	position := anInteger!

readOnlyFileNamed: fileName
	stream := SixxPortableUtil readFileStreamNamed: fileName.
	self initialize!

readSixxFromSixxElement: sixxElement
	^Object readSixxFromSixxElement: sixxElement context: self contextDictionary!

recoveredStreamFrom: aStream
	| contents startIndexes endIndexes recoverStream |
	contents := aStream contents.
	startIndexes := self findStringIndexes: '<sixx.object' from: contents.
	endIndexes := self findStringIndexes: '</sixx.object>' from: contents.
	recoverStream := ReadWriteStream with: (contents copyFrom: 1 to: startIndexes last - 1).
	startIndexes size - endIndexes size - 1 
		timesRepeat: [recoverStream nextPutAll: '</sixx.object>'].
	recoverStream nextPutAll: '</sixx>'.
	^recoverStream reset!

reset
	self privatePosition: 0!

sixxElements
	^sixxElements!

size
	^self limit!

skip: anInteger
	self position: self position + anInteger!

stream
	^stream! !
!SixxReadStream categoriesFor: #atEnd!public!testing! !
!SixxReadStream categoriesFor: #cachedObjects!accessing!public! !
!SixxReadStream categoriesFor: #checkSixxElement:!private! !
!SixxReadStream categoriesFor: #close!file open/close!public! !
!SixxReadStream categoriesFor: #contents!public!reading! !
!SixxReadStream categoriesFor: #contextDictionary!accessing!public! !
!SixxReadStream categoriesFor: #findStringIndexes:from:!private!private-recovery! !
!SixxReadStream categoriesFor: #initialize!initializing!public! !
!SixxReadStream categoriesFor: #limit!accessing!public! !
!SixxReadStream categoriesFor: #next!public!reading! !
!SixxReadStream categoriesFor: #next:!public!reading! !
!SixxReadStream categoriesFor: #on:!initializing!public! !
!SixxReadStream categoriesFor: #parseStream:!private! !
!SixxReadStream categoriesFor: #peek!public!reading! !
!SixxReadStream categoriesFor: #position!public!reading! !
!SixxReadStream categoriesFor: #position:!public!reading! !
!SixxReadStream categoriesFor: #privatePosition:!private!private-accessing! !
!SixxReadStream categoriesFor: #readOnlyFileNamed:!initializing!public! !
!SixxReadStream categoriesFor: #readSixxFromSixxElement:!private! !
!SixxReadStream categoriesFor: #recoveredStreamFrom:!private!private-recovery! !
!SixxReadStream categoriesFor: #reset!public!reading! !
!SixxReadStream categoriesFor: #sixxElements!accessing!public! !
!SixxReadStream categoriesFor: #size!public!reading! !
!SixxReadStream categoriesFor: #skip:!public!reading! !
!SixxReadStream categoriesFor: #stream!accessing!public! !

!SixxReadStream class methodsFor!

new
	self error: 'Streams are created with on:'!

on: readStream
	^self basicNew on: readStream!

readOnlyFileNamed: fileName
	^self basicNew readOnlyFileNamed: fileName! !
!SixxReadStream class categoriesFor: #new!instance creation!public! !
!SixxReadStream class categoriesFor: #on:!instance creation!public! !
!SixxReadStream class categoriesFor: #readOnlyFileNamed:!instance creation!public! !

SixxSetting guid: (GUID fromString: '{34DAB781-B68C-4960-BF35-A2F90082F8CD}')!
SixxSetting comment: ''!
!SixxSetting categoriesForClass!Unclassified! !
!SixxSetting class methodsFor!

useCDATA
	useCDATA isNil ifTrue: [useCDATA := false].
	^useCDATA!

useCDATA: aBoolean
	useCDATA := aBoolean!

useEnvironment
	useEnvironment isNil ifTrue: [useEnvironment := false].
	^useEnvironment!

useEnvironment: aBoolean
	useEnvironment := aBoolean!

useRecoveryRead
	useRecoveryRead isNil ifTrue: [useRecoveryRead := false].
	^useRecoveryRead!

useRecoveryRead: aBoolean
	useRecoveryRead := aBoolean! !
!SixxSetting class categoriesFor: #useCDATA!accessing!public! !
!SixxSetting class categoriesFor: #useCDATA:!accessing!public! !
!SixxSetting class categoriesFor: #useEnvironment!accessing!public! !
!SixxSetting class categoriesFor: #useEnvironment:!accessing!public! !
!SixxSetting class categoriesFor: #useRecoveryRead!accessing!public! !
!SixxSetting class categoriesFor: #useRecoveryRead:!accessing!public! !

SixxWriteStream guid: (GUID fromString: '{B2FFA065-F0EE-4630-B028-452ABF496EDB}')!
SixxWriteStream comment: ''!
!SixxWriteStream categoriesForClass!Kernel-Objects! !
!SixxWriteStream methodsFor!

close
	self endTag.
	self stream close!

contextDictionary
	^contextDictionary!

contextDictionary: aValue
	contextDictionary := aValue!

cr
	self stream cr!

endTag
	(self isStartTagPut and: [self isEndTagPut not]) 
		ifTrue: 
			[self stream nextPutAll: SixxConstants sixxEndTag.
			self isEndTagPut: true]!

initialize
	contextDictionary := IdentityDictionary new.
	isStartTagPut := false.
	isEndTagPut := false!

isEndTagPut
	^isEndTagPut!

isEndTagPut: aValue
	isEndTagPut := aValue!

isStartTagPut
	^isStartTagPut!

isStartTagPut: aValue
	isStartTagPut := aValue!

newFileNamed: fileName
	stream := SixxPortableUtil writeFileStreamNamed: fileName.
	self initialize!

nextPut: anObject
	self startTag.
	anObject 
		sixxOn: self stream
		indent: 1
		context: self contextDictionary!

nextPutAll: aCollection
	aCollection do: [:obj | self nextPut: obj]!

on: aStream
	stream := aStream!

rawContents
	^self stream contents!

startTag
	self isStartTagPut 
		ifFalse: 
			[self stream nextPutAll: SixxConstants sixxStartTag.
			self isStartTagPut: true.
			self cr]!

stream
	^stream!

stream: aValue
	stream := aValue!

xmlDeclaration
	(self stream)
		nextPutAll: SixxConstants xmlDeclaration;
		cr! !
!SixxWriteStream categoriesFor: #close!file open/close!public! !
!SixxWriteStream categoriesFor: #contextDictionary!accessing!public! !
!SixxWriteStream categoriesFor: #contextDictionary:!accessing!public! !
!SixxWriteStream categoriesFor: #cr!public!writing! !
!SixxWriteStream categoriesFor: #endTag!public!writing! !
!SixxWriteStream categoriesFor: #initialize!initializing!public! !
!SixxWriteStream categoriesFor: #isEndTagPut!accessing!public! !
!SixxWriteStream categoriesFor: #isEndTagPut:!accessing!public! !
!SixxWriteStream categoriesFor: #isStartTagPut!accessing!public! !
!SixxWriteStream categoriesFor: #isStartTagPut:!accessing!public! !
!SixxWriteStream categoriesFor: #newFileNamed:!initializing!public! !
!SixxWriteStream categoriesFor: #nextPut:!public!writing! !
!SixxWriteStream categoriesFor: #nextPutAll:!public!writing! !
!SixxWriteStream categoriesFor: #on:!initializing!public! !
!SixxWriteStream categoriesFor: #rawContents!actions!public! !
!SixxWriteStream categoriesFor: #startTag!public!writing! !
!SixxWriteStream categoriesFor: #stream!accessing!public! !
!SixxWriteStream categoriesFor: #stream:!accessing!public! !
!SixxWriteStream categoriesFor: #xmlDeclaration!public!writing! !

!SixxWriteStream class methodsFor!

new
	^super new initialize!

newFileNamed: fileName
	^self new newFileNamed: fileName!

on: writeStream
	^self new on: writeStream!

onWithDeclaration: writeStream
	^(self on: writeStream) xmlDeclaration! !
!SixxWriteStream class categoriesFor: #new!instance creation!public! !
!SixxWriteStream class categoriesFor: #newFileNamed:!instance creation!public! !
!SixxWriteStream class categoriesFor: #on:!instance creation!public! !
!SixxWriteStream class categoriesFor: #onWithDeclaration:!instance creation!public! !

SixxXmlUtil guid: (GUID fromString: '{D27DD491-6B27-4732-9D8F-1C5E8F12A475}')!
SixxXmlUtil comment: ''!
!SixxXmlUtil categoriesForClass!Kernel-Objects! !
!SixxXmlUtil class methodsFor!

asXmlText: aString
	| wStr |
	wStr := WriteStream on: (String new: aString size).
	^(self writeXmlText: aString on: wStr) contents!

attributeAt: attributeName from: sixxElement
	^self parserAdapter attributeAt: attributeName from: sixxElement!

characterDataFrom: sixxElement
	^self parserAdapter characterDataFrom: sixxElement!

contentsWithXmlDeclaration: aString
	| wStr |
	wStr := WriteStream on: (String new: 1024).
	wStr nextPutAll: self xmlDeclaration.
	2 timesRepeat: 
			[wStr nextPut: Character cr.
			wStr nextPut: Character lf].
	wStr nextPutAll: aString.
	^wStr contents!

convertCharDict
	^convertCharDict!

convertWriteXmlText: aString on: aWriteStream
	| cDict wStr |
	cDict := self convertCharDict.
	wStr := aWriteStream.
	aString do: 
			[:eachChar | 
			| val |
			val := eachChar asciiValue.
			val >= 127 
				ifTrue: 
					[wStr
						nextPutAll: '&#';
						nextPutAll: val printString;
						nextPut: $;]
				ifFalse: 
					[| conv |
					conv := cDict at: val ifAbsent: [].
					conv isNil ifTrue: [wStr nextPut: eachChar] ifFalse: [wStr nextPutAll: conv]]].
	^wStr!

elementsFrom: sixxElement
	"Quick hack for Dolphin YAXO "

	^(self parserAdapter elementsFrom: sixxElement) 
		select: [:each | each isKindOf: XMLElement]!

initConvertCharDict
	"SixxXmlUtil convertCharDict"

	convertCharDict := Dictionary new.
	0 to: 47 do: [:each | convertCharDict at: each put: '&#' , each printString , ';'].
	convertCharDict
		at: $& asciiValue put: '&amp;';
		at: $< asciiValue put: '&lt;';
		at: $> asciiValue put: '&gt;';
		at: $' asciiValue put: '&apos;';
		at: $" asciiValue put: '&quot;'.
	convertCharDict
		removeKey: Character space asciiValue;
		removeKey: Character tab asciiValue;
		removeKey: Character cr asciiValue;
		removeKey: Character lf asciiValue.
	convertCharDict
		removeKey: $/ asciiValue;
		removeKey: $- asciiValue;
		removeKey: $. asciiValue!

initialize
	"SixxXmlUtil initialize"

	self initConvertCharDict.
	parserAdapter := nil!

isTextFrom: sixxElement
	^self parserAdapter isTextFrom: sixxElement!

nameFrom: sixxElement
	^self parserAdapter nameFrom: sixxElement!

parserAdapter
	parserAdapter isNil ifTrue: [parserAdapter := self environment at: #SixxYaxoXmlParserAdapter].
	^parserAdapter!

parserAdapter: aSixxXmlParserAdapter
	parserAdapter := aSixxXmlParserAdapter!

parseXml: xmlStringOrStream 
	^[self parserAdapter parseXml: xmlStringOrStream] on: Error
		do: [:ex | SixxPortableUtil signalException: (SixxXmlParseError originalError: ex)]!

writeXmlText: aString on: aWriteStream
	SixxSetting useCDATA 
		ifTrue: 
			[aWriteStream nextPutAll: '<!![CDATA['.
			aWriteStream nextPutAll: aString.
			aWriteStream nextPutAll: ']]>']
		ifFalse: [self convertWriteXmlText: aString on: aWriteStream]! !
!SixxXmlUtil class categoriesFor: #asXmlText:!actions!public! !
!SixxXmlUtil class categoriesFor: #attributeAt:from:!actions-parse!public! !
!SixxXmlUtil class categoriesFor: #characterDataFrom:!actions-parse!public! !
!SixxXmlUtil class categoriesFor: #contentsWithXmlDeclaration:!actions!public! !
!SixxXmlUtil class categoriesFor: #convertCharDict!accessing!public! !
!SixxXmlUtil class categoriesFor: #convertWriteXmlText:on:!private!private-initialize! !
!SixxXmlUtil class categoriesFor: #elementsFrom:!actions-parse!public! !
!SixxXmlUtil class categoriesFor: #initConvertCharDict!private!private-initialize! !
!SixxXmlUtil class categoriesFor: #initialize!class initialization!public! !
!SixxXmlUtil class categoriesFor: #isTextFrom:!actions-parse!public! !
!SixxXmlUtil class categoriesFor: #nameFrom:!actions-parse!public! !
!SixxXmlUtil class categoriesFor: #parserAdapter!accessing!public! !
!SixxXmlUtil class categoriesFor: #parserAdapter:!accessing!public! !
!SixxXmlUtil class categoriesFor: #parseXml:!actions!public! !
!SixxXmlUtil class categoriesFor: #writeXmlText:on:!actions!public! !

SixxXmlParseError guid: (GUID fromString: '{E1B4546D-8E24-448A-B5D0-26B5DA96B328}')!
SixxXmlParseError comment: ''!
!SixxXmlParseError categoriesForClass!Kernel-Exception Handling! !
!SixxXmlParseError methodsFor!

originalError
	^originalError!

originalError: anError
	originalError := anError! !
!SixxXmlParseError categoriesFor: #originalError!accessing!public! !
!SixxXmlParseError categoriesFor: #originalError:!accessing!public! !

!SixxXmlParseError class methodsFor!

originalError: anError
	^super new originalError: anError! !
!SixxXmlParseError class categoriesFor: #originalError:!instance creation!public! !

SixxWarning guid: (GUID fromString: '{AD68B160-AEAC-4A46-B6F5-F1A877DEDAE5}')!
SixxWarning comment: ''!
!SixxWarning categoriesForClass!Unclassified! !
!SixxWarning methodsFor!

className
	^className!

className: anObject
	className := anObject
!

context
	^context!

context: anObject
	context := anObject!

defaultAction
	Transcript
		cr;
		show: '#warning# ' , self description.
	"self resume"
	^ nil!

element
	^element!

element: anObject
	element := anObject! !
!SixxWarning categoriesFor: #className!accessing!public! !
!SixxWarning categoriesFor: #className:!accessing!public! !
!SixxWarning categoriesFor: #context!accessing!public! !
!SixxWarning categoriesFor: #context:!accessing!public! !
!SixxWarning categoriesFor: #defaultAction!exception description!public! !
!SixxWarning categoriesFor: #element!accessing!public! !
!SixxWarning categoriesFor: #element:!accessing!public! !

!SixxWarning class methodsFor!

signal: className
	^self signal: className context: nil !

signal: className context: dictionary 
	^self signal: className element: nil context: dictionary !

signal: className element: xmlElement 
	^self signal: className element: xmlElement context: nil !

signal: className element: xmlElement context: dictionary 
	| inst |
	inst := self new.
	inst className: className.
	inst element: xmlElement.
	inst context: dictionary.
	^ inst signal! !
!SixxWarning class categoriesFor: #signal:!instance creation!public! !
!SixxWarning class categoriesFor: #signal:context:!instance creation!public! !
!SixxWarning class categoriesFor: #signal:element:!instance creation!public! !
!SixxWarning class categoriesFor: #signal:element:context:!instance creation!public! !

SixxClassNotFound guid: (GUID fromString: '{76FA86BB-4AE8-47BC-B99A-104171471CAD}')!
SixxClassNotFound comment: ''!
!SixxClassNotFound categoriesForClass!Kernel-Exception Handling! !
!SixxClassNotFound methodsFor!

description
	"Return a textual description of the exception."

	self className isNil 
		ifTrue: [^super description , ': ' , 'Type cannot be detected from XML'].
	^super description , ': ' , self className! !
!SixxClassNotFound categoriesFor: #description!exception description!public! !

SixxInvalidDeserialization guid: (GUID fromString: '{40F86E6A-4F44-4FF6-B08D-B42294819D7A}')!
SixxInvalidDeserialization comment: ''!
!SixxInvalidDeserialization categoriesForClass!Unclassified! !
!SixxInvalidDeserialization methodsFor!

description
	"Return a textual description of the exception."
	^ super description , ': ' , self className printString! !
!SixxInvalidDeserialization categoriesFor: #description!exception description!public! !

SixxInvalidSerialization guid: (GUID fromString: '{A02D43FB-CCCB-4BAE-B7A6-EAC4FDDEC2B5}')!
SixxInvalidSerialization comment: ''!
!SixxInvalidSerialization categoriesForClass!Unclassified! !
!SixxInvalidSerialization methodsFor!

description
	"Return a textual description of the exception."
	^ super description , ': ' , self className printString! !
!SixxInvalidSerialization categoriesFor: #description!exception description!public! !

SixxNewFailed guid: (GUID fromString: '{4487245E-B90A-4BD6-9AFE-D98C44E03512}')!
SixxNewFailed comment: ''!
!SixxNewFailed categoriesForClass!Unclassified! !
"Binary Globals"!

"Resources"!

