| package |
package := Package name: 'SIXX-Dolphin'.
package paxVersion: 0;
	basicComment: ''.

package basicScriptAt: #postuninstall put: '!!Metaclass methodsFor!!
soleInstance
"Answer the receiver''s singleton instance (the actual class object)."
#rbFix. "Dolphin normally uses #instanceClass"
^instanceClass
!! !!
!!Metaclass categoriesFor: #soleInstance!!accessing!!public!! !!

'.
package basicScriptAt: #preuninstall put: 'soleInstance
	"Answer the receiver''s singleton instance (the actual class object)."

	#rbFix.	"Dolphin normally uses #instanceClass"
	^instanceClass'.

package classNames
	add: #SixxPortableUtil;
	yourself.

package methodNames
	add: #Metaclass -> #soleInstance;
	add: #RunArray -> #runs;
	add: #RunArray -> #values;
	add: #String -> #findString:startingAt:;
	add: 'Object class' -> #readFrom:;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package allResourceNames: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\Object Arts\Dolphin\Base\Dolphin';
	yourself).

package!

"Class Definitions"!

Object subclass: #SixxPortableUtil
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: 'setting'!

"Global Aliases"!


"Loose Methods"!

!Metaclass methodsFor!

soleInstance
	"Added for Sixx"
	^self instanceClass
! !
!Metaclass categoriesFor: #soleInstance!accessing!public! !

!Object class methodsFor!

readFrom: aStream
	"Dolphin Specific"

	"Create an object based on the contents of aStream."

	| stream object |
	stream  := aStream isString ifTrue: [aStream readStream] ifFalse:[aStream].
	object := Compiler evaluate: stream contents.
	(object isKindOf: self) ifFalse: [self error: self name , ' expected'].
	^object! !
!Object class categoriesFor: #readFrom:!instance creation!public! !

!RunArray methodsFor!

runs
	^runs!

values
	"Answer the values in the receiver."

	^values! !
!RunArray categoriesFor: #runs!accessing-sixx!public! !
!RunArray categoriesFor: #values!accessing-sixx!public! !

!String methodsFor!

findString: subString startingAt: start
	"Answer the index of subString within the receiver, starting at start.
	If no such match is found, answer 0. "

	^self indexOfSubCollection: subString startingAt: start! !
!String categoriesFor: #findString:startingAt:!accessing-sixx!public! !

"End of package definition"!

"Source Globals"!

"Classes"!

SixxPortableUtil guid: (GUID fromString: '{BD64EE0B-A2EA-4D28-BAA8-48C89FDF7F4B}')!
SixxPortableUtil comment: ''!
!SixxPortableUtil categoriesForClass!Unclassified! !
!SixxPortableUtil class methodsFor!

classAt: localClassName in: environmentQualifier
	"#Dophin Smalltalk Specific#"

	| foundClass classNameSymbol |
	foundClass := nil.
	classNameSymbol := localClassName asSymbol.
	foundClass := self setting useEnvironment 
				ifTrue: 
					[| env |
					env := environmentQualifier isNil 
								ifTrue: [Smalltalk]
								ifFalse: 
									["Currently Dophin Smalltalk does not support  
									namespace, so just ignore"

									Smalltalk].
					env at: classNameSymbol ifAbsent: []]
				ifFalse: [Smalltalk at: classNameSymbol ifAbsent: []].
	^foundClass!

environmentQualifierOf: aClass
	"#Dolphin Smalltalk Specific#"

	"Currently Dolphin Smalltalkdoes not support namespace, so just ignore"

	^'Smalltalk'!

initialize
	setting := nil!

obsolete
	self initialize!

readFileStreamNamed: aFilenameString
	"#Dophin Smalltalk Specific#"

	^FileStream read: aFilenameString!

setting
	setting isNil
		ifTrue: [setting := Smalltalk
						at: #SixxSetting
						ifAbsent: [self error: 'SixxSetting is needed to run SIXX']].
	^ setting!

signalException: anException
	"#Dophin Smalltalk Specific#"

	^anException signal!

writeFileStreamNamed: aFilename
	"#Dolphin Smalltalk Specific#"

	^FileStream write: aFilename! !
!SixxPortableUtil class categoriesFor: #classAt:in:!actions!public! !
!SixxPortableUtil class categoriesFor: #environmentQualifierOf:!actions!public! !
!SixxPortableUtil class categoriesFor: #initialize!class initialization!public! !
!SixxPortableUtil class categoriesFor: #obsolete!class initialization!public! !
!SixxPortableUtil class categoriesFor: #readFileStreamNamed:!actions!public! !
!SixxPortableUtil class categoriesFor: #setting!accessing!public! !
!SixxPortableUtil class categoriesFor: #signalException:!actions!public! !
!SixxPortableUtil class categoriesFor: #writeFileStreamNamed:!actions!public! !

"Binary Globals"!

"Resources"!

