| package |
package := Package name: 'SIXX-InOut-Dolphin'.
package paxVersion: 0;
	basicComment: ''.


package classNames
	add: #SixxColor;
	yourself.

package methodNames
	add: #Color -> #sixxContentOn:indent:context:;
	add: #ColorRef -> #sixxContentOn:indent:context:;
	add: #Date -> #sixxContentString;
	add: #DOUBLEArray -> #sixxContentOn:indent:context:;
	add: #EventMessageSend -> #sixxContentOn:indent:context:;
	add: #FLOATArray -> #sixxContentOn:indent:context:;
	add: #Integer -> #shortHexString;
	add: #MethodContext -> #sixxContentOn:indent:context:;
	add: #Process -> #sixxContentOn:indent:context:;
	add: #SystemColor -> #sixxContentOn:indent:context:;
	add: #Time -> #sixxContentString;
	add: #WORDArray -> #sixxContentOn:indent:context:;
	add: 'Color class' -> #createInstanceOf:withSixxElement:;
	add: 'Color class' -> #r:g:b:;
	add: 'ColorRef class' -> #createInstanceOf:withSixxElement:;
	add: 'Date class' -> #sixxMonthIndexOf:;
	add: 'Date class' -> #sixxNameOfMonth:;
	add: 'DeadObject class' -> #createInstanceOf:withSixxElement:;
	add: 'DeafObject class' -> #createInstanceOf:withSixxElement:;
	add: 'DOUBLEArray class' -> #createInstanceOf:withSixxElement:;
	add: 'EventMessageSend class' -> #createInstanceOf:withSixxElement:;
	add: 'FLOATArray class' -> #createInstanceOf:withSixxElement:;
	add: 'MethodContext class' -> #createInstanceOf:withSixxElement:;
	add: 'Process class' -> #createInstanceOf:withSixxElement:;
	add: 'Time class' -> #readSixxContentStringFrom:;
	add: 'WORDArray class' -> #createInstanceOf:withSixxElement:;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package allResourceNames: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\Object Arts\Dolphin\MVP\Base\Dolphin MVP Base';
	add: 'SIXX-Core';
	yourself).

package!

"Class Definitions"!

RGB subclass: #SixxColor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

!Color methodsFor!

sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self storeString! !
!Color categoriesFor: #sixxContentOn:indent:context:!printing-sixx!public! !

!Color class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement
	^self readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement))!

r: redValue g: greenValue b: blueValue
	"Dolphin Specific"
	^self red: (redValue * 255) rounded
	 green: (greenValue * 255) rounded	
	blue: (blueValue* 255) rounded
! !
!Color class categoriesFor: #createInstanceOf:withSixxElement:!instance creation-sixx!public! !
!Color class categoriesFor: #r:g:b:!instance creation!public! !

!ColorRef methodsFor!

sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self code printString! !
!ColorRef categoriesFor: #sixxContentOn:indent:context:!printing-sixx!public! !

!ColorRef class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement
	^self fromInteger: (SixxXmlUtil characterDataFrom: sixxElement) asNumber! !
!ColorRef class categoriesFor: #createInstanceOf:withSixxElement:!instance creation-sixx!public! !

!Date methodsFor!

sixxContentString
	"Dolphin Specific"
	| wStr |
	wStr := WriteStream on: (String new: 64).
	wStr nextPutAll: self dayOfMonth printString.
	wStr space.
	wStr nextPutAll: (self class sixxNameOfMonth: self monthIndex).
	wStr space.
	wStr nextPutAll: self year printString.
	^wStr  contents! !
!Date categoriesFor: #sixxContentString!private-sixx!public! !

!Date class methodsFor!

sixxMonthIndexOf: monthName
	^(Locale lcid: 1033) monthNames at: monthName asLowercase


!

sixxNameOfMonth: monthIndex
	^(Locale lcid: 1033) nameOfMonth: monthIndex abbrev: false! !
!Date class categoriesFor: #sixxMonthIndexOf:!public!utility-sixx! !
!Date class categoriesFor: #sixxNameOfMonth:!public!utility-sixx! !

!DeadObject class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement
	^self current! !
!DeadObject class categoriesFor: #createInstanceOf:withSixxElement:!instance creation-sixx!public! !

!DeafObject class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement
	^self current! !
!DeafObject class categoriesFor: #createInstanceOf:withSixxElement:!instance creation-sixx!public! !

!DOUBLEArray methodsFor!

sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: '#( '.
	self do: 
			[:each | 
			aStream
				nextPutAll: each printString;
				space].
	aStream nextPutAll: ')'! !
!DOUBLEArray categoriesFor: #sixxContentOn:indent:context:!printing-sixx!public! !

!DOUBLEArray class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement
	| col |
	col := Array readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement)).
	^self withAll: col! !
!DOUBLEArray class categoriesFor: #createInstanceOf:withSixxElement:!instance creation-sixx!public! !

!EventMessageSend methodsFor!

sixxContentOn: aStream indent: level context: dictionary
	"TEMPORALY: We will redesign Message serialization in the next release"
	SixxInvalidSerialization signal: self class name context: dictionary.
	aStream nextPutAll: self storeString
! !
!EventMessageSend categoriesFor: #sixxContentOn:indent:context:!printing-sixx!public! !

!EventMessageSend class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement
	"TEMPORALY: We will redesign Message serialization in the next release"
	SixxInvalidDeserialization signal: aClass name element: sixxElement. 
	^nil! !
!EventMessageSend class categoriesFor: #createInstanceOf:withSixxElement:!instance creation-sixx!public! !

!FLOATArray methodsFor!

sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: '#( '.
	self do: 
			[:each | 
			aStream
				nextPutAll: each printString;
				space].
	aStream nextPutAll: ')'! !
!FLOATArray categoriesFor: #sixxContentOn:indent:context:!printing-sixx!public! !

!FLOATArray class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement
	| col |
	col := Array readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement)).
	^self withAll: col! !
!FLOATArray class categoriesFor: #createInstanceOf:withSixxElement:!instance creation-sixx!public! !

!Integer methodsFor!

shortHexString
	| current letters digits quo i |
	digits := '0123456789ABCDEF'.
	current := self.
	i := self digitSize * 8.	"Dolphin Specific"
	letters := String new: i.
	[current < 16] whileFalse: 
			[quo := current quo: 16.
			letters at: i put: (digits at: current - (quo * 16) + 1).
			i := i - 1.
			current := quo].
	letters at: i put: (digits at: current + 1).
	^letters copyFrom: i to: letters size! !
!Integer categoriesFor: #shortHexString!printing!public! !

!MethodContext methodsFor!

sixxContentOn: aStream indent: level context: dictionary
	SixxInvalidSerialization signal: self class name context: dictionary.
	aStream nextPutAll: self printString! !
!MethodContext categoriesFor: #sixxContentOn:indent:context:!printing-sixx!public! !

!MethodContext class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement
	SixxInvalidDeserialization signal: aClass name element: sixxElement. 
	^nil
	
	! !
!MethodContext class categoriesFor: #createInstanceOf:withSixxElement:!instance creation-sixx!public! !

!Process methodsFor!

sixxContentOn: aStream indent: level context: dictionary
	SixxInvalidSerialization signal: self class name context: dictionary.
	aStream nextPutAll: self storeString! !
!Process categoriesFor: #sixxContentOn:indent:context:!printing-sixx!public! !

!Process class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement
	SixxInvalidDeserialization signal: aClass name element: sixxElement. 
	^nil
	! !
!Process class categoriesFor: #createInstanceOf:withSixxElement:!instance creation-sixx!public! !

!SystemColor methodsFor!

sixxContentOn: aStream indent: level context: dictionary
	aStream
		nextPut: $(;
		display: self class;
		display: ' fromId: ';
		display: self id;
		nextPut: $)! !
!SystemColor categoriesFor: #sixxContentOn:indent:context:!printing-sixx!public! !

!Time methodsFor!

sixxContentString
	"Dolphin Specific"
	"Format is hh:mm tt' or 'h:mm tt' (as in Squeak)"

	| wStr h m s |
	wStr := WriteStream on: (String new: 16).

	h := self hours.
	m := self minutes.
	s := self seconds.
	
	h > 12 ifTrue: [wStr  print: h - 12]
		ifFalse: [wStr print: h].

	wStr nextPutAll: (m < 10 ifTrue: [':0'] ifFalse: [':']).
	wStr print: m.

	wStr nextPutAll: (s < 10 ifTrue: [':0'] ifFalse: [':']).
	wStr print: s.

	wStr nextPutAll: (h < 12 ifTrue: [' am'] ifFalse: [' pm']).
	
	^wStr contents
! !
!Time categoriesFor: #sixxContentString!private-sixx!public! !

!Time class methodsFor!

readSixxContentStringFrom: aStream
	"Dolphin Specific"
	"Read a Time from the stream in the form:
		<hour>:<minute>:<second> <am/pm>

	<minute>, <second> or <am/pm> may be omitted.  e.g. 1:59:30 pm; 8AM; 15:30"
	"Time readFrom: (ReadStream on: '2:23:09 pm')"

	| hour minute second ampm |
	hour := Integer readFrom: aStream.
	minute := 0.
	second := 0.
	(aStream peekFor: $:) 
		ifTrue: 
			[minute := Integer readFrom: aStream.
			(aStream peekFor: $:) ifTrue: [second := Integer readFrom: aStream]].
	aStream skipSeparators.
	(aStream atEnd not and: [aStream peek isLetter]) 
		ifTrue: 
			[ampm := aStream next asLowercase.
			(ampm = $p and: [hour < 12]) ifTrue: [hour := hour + 12].
			(ampm = $a and: [hour = 12]) ifTrue: [hour := 0].
			(aStream peekFor: $m) ifFalse: [aStream peekFor: $M]].
	^self fromSeconds: 60 * (60 * hour + minute) + second

	
! !
!Time class categoriesFor: #readSixxContentStringFrom:!private-sixx!public! !

!WORDArray methodsFor!

sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: '#( '.
	self do: 
			[:each | 
			aStream
				nextPutAll: each printString;
				space].
	aStream nextPutAll: ')'! !
!WORDArray categoriesFor: #sixxContentOn:indent:context:!printing-sixx!public! !

!WORDArray class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement
	| col |
	col := Array readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement)).
	^col asWordArray! !
!WORDArray class categoriesFor: #createInstanceOf:withSixxElement:!instance creation-sixx!public! !

"End of package definition"!

"Source Globals"!

"Classes"!

SixxColor guid: (GUID fromString: '{6B72E803-42EF-4035-9449-D7407E50EFA1}')!
SixxColor comment: ''!
!SixxColor categoriesForClass!Unclassified! !
!SixxColor methodsFor!

sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: '(Color r: ';
		nextPutAll: (self red / 255)  asFloat printString;
		nextPutAll: ' g: ';
		nextPutAll: (self green / 255) asFloat printString;
		nextPutAll: ' b: ';
		nextPutAll: (self blue / 255) asFloat printString;
		nextPutAll: ')'!

sixxType
	^#Color! !
!SixxColor categoriesFor: #sixxContentOn:indent:context:!printing-sixx!public! !
!SixxColor categoriesFor: #sixxType!private-sixx!public! !

!SixxColor class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement
	^aClass readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement))! !
!SixxColor class categoriesFor: #createInstanceOf:withSixxElement:!instance creation-sixx!public! !

"Binary Globals"!

"Resources"!

