| package |
package := Package name: 'SIXX-InOut'.
package paxVersion: 0;
	basicComment: ''.


package methodNames
	add: #ArrayedCollection -> #initializeFromSixxElement:context:;
	add: #Behavior -> #classFromSixxElement:context:;
	add: #Behavior -> #createInstanceOf:withSixxElement:;
	add: #Behavior -> #createMixedFieldsInstanceOf:withSixxElement:;
	add: #Behavior -> #envFromSixxElement:;
	add: #Behavior -> #fromSixxElement:context:;
	add: #Behavior -> #idFromSixxElement:;
	add: #Behavior -> #idrefFromSixxElement:;
	add: #Behavior -> #includesRefInstanceFromSixxElement:context:;
	add: #Behavior -> #nameFromSixxElement:;
	add: #Behavior -> #newInstanceFromSixxElement:context:;
	add: #Behavior -> #readSixxFrom:;
	add: #Behavior -> #readSixxFrom:context:;
	add: #Behavior -> #readSixxFromSixxElement:context:;
	add: #Behavior -> #refInstanceFromSixxElement:context:;
	add: #Behavior -> #sixxNew:size:withSixxElement:;
	add: #Behavior -> #sixxNew:withSixxElement:;
	add: #Behavior -> #typeFromSixxElement:;
	add: #Boolean -> #sixxContentOn:indent:context:;
	add: #ByteArray -> #shortHexString;
	add: #ByteArray -> #sixxContentOn:indent:context:;
	add: #Character -> #sixxContentOn:indent:context:;
	add: #ClassDescription -> #sixxContentOn:indent:context:;
	add: #Collection -> #initializeFromSixxElement:context:;
	add: #Collection -> #sixxContentOn:indent:context:;
	add: #Collection -> #sixxIndexFieldsOn:indent:context:;
	add: #Collection -> #sixxMixedFieldsOn:indent:context:;
	add: #Date -> #sixxContentOn:indent:context:;
	add: #Dictionary -> #sixxContentOn:indent:context:;
	add: #Interval -> #sixxContentOn:indent:context:;
	add: #Metaclass -> #createInstanceOf:withSixxElement:;
	add: #Number -> #sixxContentOn:indent:context:;
	add: #Object -> #initializeFromSixxElement:context:;
	add: #Object -> #initializeIndexFieldsFromSixxElement:context:;
	add: #Object -> #initializeInstVarsFromSixxElement:context:;
	add: #Object -> #initializeMixedFieldsFromSixxElement:context:;
	add: #Object -> #sixxAt:put:;
	add: #Object -> #sixxChildrenContentsOn:indent:context:;
	add: #Object -> #sixxContentOn:indent:context:;
	add: #Object -> #sixxEnv;
	add: #Object -> #sixxEnvAttribString;
	add: #Object -> #sixxIdAttribString:;
	add: #Object -> #sixxIndexFieldsOn:indent:context:;
	add: #Object -> #sixxInitialize;
	add: #Object -> #sixxInstVarNamed:put:;
	add: #Object -> #sixxInstVarsOn:indent:context:;
	add: #Object -> #sixxMixedFieldsOn:indent:context:;
	add: #Object -> #sixxNameAttribString:;
	add: #Object -> #sixxOn:;
	add: #Object -> #sixxOn:indent:context:;
	add: #Object -> #sixxOn:name:indent:context:;
	add: #Object -> #sixxRefTagStartString:;
	add: #Object -> #sixxRefTagStartString:name:;
	add: #Object -> #sixxString;
	add: #Object -> #sixxTagEndString;
	add: #Object -> #sixxTagStartString:name:;
	add: #Object -> #sixxType;
	add: #Object -> #sixxTypeAttribString;
	add: #Point -> #sixxContentOn:indent:context:;
	add: #RunArray -> #initializeFromSixxElement:context:;
	add: #RunArray -> #sixxContentOn:indent:context:;
	add: #String -> #sixxContentOn:indent:context:;
	add: #Time -> #sixxContentOn:indent:context:;
	add: #UndefinedObject -> #asSixxKey;
	add: #UndefinedObject -> #sixxContentOn:indent:context:;
	add: #UndefinedObject -> #sixxOn:name:indent:context:;
	add: 'Boolean class' -> #createInstanceOf:withSixxElement:;
	add: 'ByteArray class' -> #createInstanceOf:withSixxElement:;
	add: 'ByteArray class' -> #readShortHexFrom:;
	add: 'Character class' -> #createInstanceOf:withSixxElement:;
	add: 'Collection class' -> #createInstanceOf:withSixxElement:;
	add: 'Date class' -> #createInstanceOf:withSixxElement:;
	add: 'Integer class' -> #readShortHexFrom:;
	add: 'Interval class' -> #createInstanceOf:withSixxElement:;
	add: 'Number class' -> #createInstanceOf:withSixxElement:;
	add: 'Point class' -> #createInstanceOf:withSixxElement:;
	add: 'String class' -> #createInstanceOf:withSixxElement:;
	add: 'Symbol class' -> #createInstanceOf:withSixxElement:;
	add: 'Time class' -> #createInstanceOf:withSixxElement:;
	add: 'UndefinedObject class' -> #createInstanceOf:withSixxElement:;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package allResourceNames: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\Object Arts\Dolphin\Base\Dolphin';
	add: 'SIXX-Core';
	add: 'SIXX-Dolphin';
	yourself).

package!

"Class Definitions"!


"Global Aliases"!


"Loose Methods"!

!ArrayedCollection methodsFor!

initializeFromSixxElement: sixxElement context: aDictionary 
	"override to use #initializeMixedFieldsFromSixxElement:context: if having some inst vars"

	| idx |
	idx := 1.
	(SixxXmlUtil elementsFrom: sixxElement) do: 
			[:elem | 
			| childInst |
			(SixxXmlUtil isTextFrom: elem) 
				ifFalse: 
					[childInst := self class fromSixxElement: elem context: aDictionary.
					self at: idx put: childInst.
					idx := idx + 1]]! !
!ArrayedCollection categoriesFor: #initializeFromSixxElement:context:!initializing-sixx!public! !

!Behavior methodsFor!

classFromSixxElement: sixxElement context: dictionary
	| isClassClass type className retClass |
	isClassClass := false.
	type := self typeFromSixxElement: sixxElement.
	type isNil ifTrue: [^nil].
	className := (type includes: Character space) 
				ifTrue: 
					[isClassClass := true.
					type upTo: Character space	"Dolphin Specific"]
				ifFalse: [type].
	retClass := SixxPortableUtil classAt: className in: (self envFromSixxElement: sixxElement).
	isClassClass ifTrue: [retClass := retClass class].
	^retClass isNil 
		ifTrue: 
			[SixxClassNotFound 
				signal: className
				element: sixxElement
				context: dictionary]
		ifFalse: [retClass]!

createInstanceOf: aClass withSixxElement: sixxElement 
	"override if you like"

	^aClass isVariable 
		ifTrue: [self createMixedFieldsInstanceOf: aClass withSixxElement: sixxElement]
		ifFalse: [self sixxNew: aClass withSixxElement: sixxElement]!

createMixedFieldsInstanceOf: aClass withSixxElement: sixxElement 
	"override if you like"

	| nonameElems size |
	nonameElems := (SixxXmlUtil elementsFrom: sixxElement) 
				select: [:each | (self nameFromSixxElement: each) isNil].
	size := nonameElems isEmpty ifTrue: [0] ifFalse: [nonameElems size].
	^self 
		sixxNew: aClass
		size: size
		withSixxElement: sixxElement!

envFromSixxElement: sixxElement
	| environmentQualifier |
	(SixxXmlUtil isTextFrom: sixxElement) ifTrue: [^nil].
	environmentQualifier := SixxXmlUtil attributeAt: #'sixx.env' from: sixxElement.
	^environmentQualifier isNil ifFalse: [environmentQualifier asSymbol]!

fromSixxElement: sixxElement context: aDictionary
	^(self includesRefInstanceFromSixxElement: sixxElement context: aDictionary) 
		ifTrue: [self refInstanceFromSixxElement: sixxElement context: aDictionary]
		ifFalse: [self newInstanceFromSixxElement: sixxElement context: aDictionary]!

idFromSixxElement: sixxElement
	| id |
	(SixxXmlUtil isTextFrom: sixxElement) ifTrue: [^nil].
	id := SixxXmlUtil attributeAt: 'sixx.id' from: sixxElement.
	^id isNil ifFalse: [id asSymbol]!

idrefFromSixxElement: sixxElement
	| idref |
	(SixxXmlUtil isTextFrom: sixxElement) ifTrue: [^nil].
	idref := SixxXmlUtil attributeAt: 'sixx.idref' from: sixxElement.
	^idref isNil ifFalse: [idref asSymbol]!

includesRefInstanceFromSixxElement: sixxElement context: aDictionary
	| idref |
	idref := self idrefFromSixxElement: sixxElement.
	^idref isNil ifTrue: [false] ifFalse: [aDictionary includesKey: idref]!

nameFromSixxElement: sixxElement
	| nm |
	(SixxXmlUtil isTextFrom: sixxElement) ifTrue: [^nil].
	nm := SixxXmlUtil attributeAt: 'sixx.name' from: sixxElement.
	^nm isNil ifFalse: [nm asSymbol]!

newInstanceFromSixxElement: sixxElement context: aDictionary 
	| class inst |
	class := self classFromSixxElement: sixxElement context: aDictionary.
	class isNil 
		ifTrue: 
			[class := SixxClassNotFound 
						signal: (self typeFromSixxElement: sixxElement)
						element: sixxElement
						context: aDictionary].
	inst := class createInstanceOf: class withSixxElement: sixxElement.
	aDictionary at: (self idFromSixxElement: sixxElement) put: inst.
	inst initializeFromSixxElement: sixxElement context: aDictionary.
	inst sixxInitialize.
	^inst!

readSixxFrom: xmlStringOrStream
	^self readSixxFrom: xmlStringOrStream context: IdentityDictionary new!

readSixxFrom: xmlStringOrStream context: aDictionary
	| topElem |
	topElem := SixxXmlUtil parseXml: xmlStringOrStream.
	^self readSixxFromSixxElement: topElem context: aDictionary!

readSixxFromSixxElement: sixxElement context: aDictionary
	| rootClass typeAttr |
	typeAttr := self typeFromSixxElement: sixxElement.
	^typeAttr isNil 
		ifTrue: 
			[(self includesRefInstanceFromSixxElement: sixxElement context: aDictionary) 
				ifTrue: [self refInstanceFromSixxElement: sixxElement context: aDictionary]]
		ifFalse: 
			[rootClass := self classFromSixxElement: sixxElement context: aDictionary.
			rootClass isNil ifFalse: [rootClass fromSixxElement: sixxElement context: aDictionary]]!

refInstanceFromSixxElement: sixxElement context: aDictionary
	| idref |
	idref := self idrefFromSixxElement: sixxElement.
	^aDictionary at: idref!

sixxNew: aClass size: size withSixxElement: sixxElement 
	^[aClass new: size] on: Error
		do: 
			[:ex | 
			| alterClass |
			alterClass := SixxNewFailed signal: aClass name element: sixxElement.
			alterClass isNil 
				ifTrue: 
					[[aClass basicNew: size] on: Error do: [self sixxNew: aClass withSixxElement: sixxElement]]
				ifFalse: [alterClass basicNew: size]]!

sixxNew: aClass withSixxElement: sixxElement 
	^[aClass new] on: Error
		do: 
			[:ex | 
			| alterClass |
			alterClass := SixxNewFailed signal: aClass name element: sixxElement.
			alterClass isNil ifTrue: [aClass basicNew] ifFalse: [alterClass basicNew]]!

typeFromSixxElement: sixxElement
	| type |
	(SixxXmlUtil isTextFrom: sixxElement) ifTrue: [^nil].
	type := SixxXmlUtil attributeAt: 'sixx.type' from: sixxElement.
	^type isNil ifFalse: [type asSymbol]! !
!Behavior categoriesFor: #classFromSixxElement:context:!private-sixx!public! !
!Behavior categoriesFor: #createInstanceOf:withSixxElement:!instance creation-sixx!public! !
!Behavior categoriesFor: #createMixedFieldsInstanceOf:withSixxElement:!instance creation-sixx!public! !
!Behavior categoriesFor: #envFromSixxElement:!private-sixx!public! !
!Behavior categoriesFor: #fromSixxElement:context:!private-sixx!public! !
!Behavior categoriesFor: #idFromSixxElement:!private-sixx!public! !
!Behavior categoriesFor: #idrefFromSixxElement:!private-sixx!public! !
!Behavior categoriesFor: #includesRefInstanceFromSixxElement:context:!private-sixx!public! !
!Behavior categoriesFor: #nameFromSixxElement:!private-sixx!public! !
!Behavior categoriesFor: #newInstanceFromSixxElement:context:!private-sixx!public! !
!Behavior categoriesFor: #readSixxFrom:!instance creation-sixx!public! !
!Behavior categoriesFor: #readSixxFrom:context:!instance creation-sixx!public! !
!Behavior categoriesFor: #readSixxFromSixxElement:context:!instance creation-sixx!public! !
!Behavior categoriesFor: #refInstanceFromSixxElement:context:!private-sixx!public! !
!Behavior categoriesFor: #sixxNew:size:withSixxElement:!instance creation-sixx!public! !
!Behavior categoriesFor: #sixxNew:withSixxElement:!instance creation-sixx!public! !
!Behavior categoriesFor: #typeFromSixxElement:!private-sixx!public! !

!Boolean methodsFor!

sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self storeString! !
!Boolean categoriesFor: #sixxContentOn:indent:context:!printing-sixx!public! !

!Boolean class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement
	^self readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement))! !
!Boolean class categoriesFor: #createInstanceOf:withSixxElement:!instance creation-sixx!public! !

!ByteArray methodsFor!

shortHexString
	| sz stream |
	sz := self size.
	stream := WriteStream on: (String new: sz * 2).
	1 to: sz
		do: 
			[:idx | 
			| elem |
			elem := self at: idx.
			elem < 16 ifTrue: [stream nextPut: $0].
			stream nextPutAll: elem shortHexString].
	^stream contents!

sixxContentOn: aStream indent: level context: dictionary 
	1 to: self size
		do: 
			[:idx | 
			| elem |
			elem := self at: idx.
			elem < 16 ifTrue: [aStream nextPut: $0].
			aStream nextPutAll: elem shortHexString]! !
!ByteArray categoriesFor: #shortHexString!converting!public! !
!ByteArray categoriesFor: #sixxContentOn:indent:context:!printing-sixx!public! !

!ByteArray class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement 
	| rawStr col |
	rawStr := ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement).
	col := rawStr peek = $# 
				ifTrue: [Array readFrom: rawStr]
				ifFalse: [self readShortHexFrom: rawStr].
	^self withAll: col!

readShortHexFrom: aStream 
	| sz inst |
	sz := aStream size // 2.
	inst := self new: sz.
	1 to: sz
		do: [:idx | inst at: idx put: (Integer readShortHexFrom: (aStream next: 2) readStream)].
	^inst! !
!ByteArray class categoriesFor: #createInstanceOf:withSixxElement:!instance creation-sixx!public! !
!ByteArray class categoriesFor: #readShortHexFrom:!instance creation!public! !

!Character methodsFor!

sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self storeString! !
!Character categoriesFor: #sixxContentOn:indent:context:!printing-sixx!public! !

!Character class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement
	^self readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement))! !
!Character class categoriesFor: #createInstanceOf:withSixxElement:!instance creation-sixx!public! !

!ClassDescription methodsFor!

sixxContentOn: aStream indent: level context: dictionary
	| instVars startIndex |
	aStream cr.
	instVars := self class allInstVarNames.
	startIndex := Object class allInstVarNames size + 1.
	startIndex to: instVars size
		do: 
			[:idx | 
			(self instVarAt: idx) 
				sixxOn: aStream
				name: (instVars at: idx)
				indent: level + 1
				context: dictionary]! !
!ClassDescription categoriesFor: #sixxContentOn:indent:context:!printing-sixx!public! !

!Collection methodsFor!

initializeFromSixxElement: sixxElement context: aDictionary 
	"override to use #initializeMixedFieldsFromSixxElement:context: if having some inst vars"

	(SixxXmlUtil elementsFrom: sixxElement) do: 
			[:elem | 
			| childInst |
			childInst := self class fromSixxElement: elem context: aDictionary.
			self add: childInst]!

sixxContentOn: aStream indent: level context: dictionary 
	"default just uses #do: - override it to use #sixxAllFieldsOn:indent:context: if your collection need to store some inst vars"

	aStream cr.
	self do: 
			[:each | 
			each 
				sixxOn: aStream
				indent: level + 1
				context: dictionary].
	aStream tab: level!

sixxIndexFieldsOn: aStream indent: level context: dictionary 
	self size = 0 ifTrue: [^self].
	aStream cr.
	self do: 
			[:each | 
			each 
				sixxOn: aStream
				indent: level
				context: dictionary]!

sixxMixedFieldsOn: aStream indent: level context: dictionary 
	"override"

	"Usually Collection's inst vars are not needed for serialization"

	self 
		sixxIndexFieldsOn: aStream
		indent: level
		context: dictionary! !
!Collection categoriesFor: #initializeFromSixxElement:context:!initializing-sixx!public! !
!Collection categoriesFor: #sixxContentOn:indent:context:!printing-sixx!public! !
!Collection categoriesFor: #sixxIndexFieldsOn:indent:context:!private-sixx!public! !
!Collection categoriesFor: #sixxMixedFieldsOn:indent:context:!private-sixx!public! !

!Collection class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement 
	"override to use #createMixedFieldsInstanceOf:withSixxElement: if you have extra inst vars"

	^self 
		sixxNew: aClass
		size: (SixxXmlUtil elementsFrom: sixxElement) size
		withSixxElement: sixxElement! !
!Collection class categoriesFor: #createInstanceOf:withSixxElement:!instance creation-sixx!public! !

!Date methodsFor!

sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self sixxContentString! !
!Date categoriesFor: #sixxContentOn:indent:context:!printing-sixx!public! !

!Date class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement
	"Dolphin specific"
	| rst day month monthStr year |
	rst := ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement).
	day := (rst upTo: Character space) asNumber.
	monthStr := rst upTo: Character space.
	month := self sixxMonthIndexOf: monthStr.
	year := rst upToEnd asNumber.
	^Date 
		newDay: day
		monthNumber: month
		year: year! !
!Date class categoriesFor: #createInstanceOf:withSixxElement:!instance creation-sixx!public! !

!Dictionary methodsFor!

sixxContentOn: aStream indent: level context: dictionary
	aStream cr.
	self associationsDo: 
			[:each | 
			each 
				sixxOn: aStream
				indent: level + 1
				context: dictionary].
	aStream tab: level! !
!Dictionary categoriesFor: #sixxContentOn:indent:context:!printing-sixx!public! !

!Integer class methodsFor!

readShortHexFrom: aStream 
	| digit value startPos |
	value := 0.
	startPos := aStream position.
	[aStream atEnd] whileFalse: 
			[digit := aStream next digitValue.
			(digit < 0 or: [digit >= 16]) 
				ifTrue: 
					[aStream skip: -1.
					aStream position = startPos ifTrue: [self error: 'At least one digit expected here'].
					^value]
				ifFalse: [value := value * 16 + digit]].
	^value! !
!Integer class categoriesFor: #readShortHexFrom:!instance creation!public! !

!Interval methodsFor!

sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self printString! !
!Interval categoriesFor: #sixxContentOn:indent:context:!printing-sixx!public! !

!Interval class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement
	^self readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement))! !
!Interval class categoriesFor: #createInstanceOf:withSixxElement:!instance creation-sixx!public! !

!Metaclass methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement
	^aClass isMeta ifTrue: [aClass soleInstance] ifFalse: [aClass]! !
!Metaclass categoriesFor: #createInstanceOf:withSixxElement:!instance creation-sixx!public! !

!Number methodsFor!

sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self printString! !
!Number categoriesFor: #sixxContentOn:indent:context:!printing-sixx!public! !

!Number class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement
	^(SixxXmlUtil characterDataFrom: sixxElement) asNumber! !
!Number class categoriesFor: #createInstanceOf:withSixxElement:!instance creation-sixx!public! !

!Object methodsFor!

initializeFromSixxElement: sixxElement context: aDictionary 
	self class isBits 
		ifTrue: [^self initializeIndexFieldsFromSixxElement: sixxElement context: aDictionary].

	self class isVariable 
		ifTrue: [^self initializeMixedFieldsFromSixxElement: sixxElement context: aDictionary].

	self initializeInstVarsFromSixxElement: sixxElement context: aDictionary!

initializeIndexFieldsFromSixxElement: sixxElement context: aDictionary 
	| idx nonameElems |
	idx := 1.
	nonameElems := (SixxXmlUtil elementsFrom: sixxElement) 
				select: [:each | (self class nameFromSixxElement: each) isNil].
	nonameElems isEmpty 
		ifFalse: 
			[nonameElems do: 
					[:elem | 
					| childInst |
					(SixxXmlUtil isTextFrom: elem) 
						ifFalse: 
							[childInst := self class fromSixxElement: elem context: aDictionary.
							self sixxAt: idx put: childInst.
							idx := idx + 1]]]!

initializeInstVarsFromSixxElement: sixxElement context: aDictionary 
	(SixxXmlUtil elementsFrom: sixxElement) do: 
			[:elem | 
			| varName |
			(SixxXmlUtil isTextFrom: elem) 
				ifFalse: 
					[varName := self class nameFromSixxElement: elem.
					varName notNil 
						ifTrue: 
							[| childInst |
							childInst := self class fromSixxElement: elem context: aDictionary.
							self sixxInstVarNamed: varName put: childInst]]]!

initializeMixedFieldsFromSixxElement: sixxElement context: aDictionary 
	self initializeInstVarsFromSixxElement: sixxElement context: aDictionary.
	self initializeIndexFieldsFromSixxElement: sixxElement context: aDictionary!

sixxAt: index put: aValue 
	"override if you like"

	self at: index put: aValue!

sixxChildrenContentsOn: aStream indent: level context: dictionary 
	self class isBits 
		ifTrue: 
			[aStream nextPutAll: '#( '.
			1 to: self size
				do: 
					[:idx | 
					aStream
						nextPutAll: (self at: idx) asString;
						space].
			aStream nextPutAll: ')'.
			^self].
	self class isVariable 
		ifTrue: 
			[^self 
				sixxMixedFieldsOn: aStream
				indent: level
				context: dictionary].
	self 
		sixxInstVarsOn: aStream
		indent: level
		context: dictionary!

sixxContentOn: aStream indent: level context: dictionary
	"override if you like"

	self 
		sixxChildrenContentsOn: aStream
		indent: level + 1
		context: dictionary.
	aStream tab: level!

sixxEnv
	^SixxPortableUtil environmentQualifierOf: self class!

sixxEnvAttribString
	^'sixx.env="' , self sixxEnv , '" '!

sixxIdAttribString: idString
	^'sixx.id="' , idString asString , '" '!

sixxIndexFieldsOn: aStream indent: level context: dictionary 
	"override if you like"

	| size |
	size := self basicSize.
	size = 0 ifTrue: [^self].
	1 to: size
		do: 
			[:i | 
			| element |
			element := self basicAt: i.
			element 
				sixxOn: aStream
				indent: level
				context: dictionary]!

sixxInitialize
	"override if you like"

	"The method is called after the loading of the receiver - just like #initializaAfterLoad in Envy"

	"It is useful to initializa attributes that cannot be stored in SIXX (Block, Context, etc)"

	!

sixxInstVarNamed: instVarName put: aValue
	"override if you like"

	self instVarAt: (self class allInstVarNames indexOf: instVarName asString) put: aValue!

sixxInstVarsOn: aStream indent: level context: dictionary 
	| instVars ind |
	aStream cr.
	instVars := self class allInstVarNames.
	ind := 0.
	instVars do: 
			[:nm | 
			ind := ind + 1.
			(self instVarAt: ind) 
				sixxOn: aStream
				name: nm
				indent: level
				context: dictionary]!

sixxMixedFieldsOn: aStream indent: level context: dictionary 
	self 
		sixxInstVarsOn: aStream
		indent: level
		context: dictionary.
	self 
		sixxIndexFieldsOn: aStream
		indent: level
		context: dictionary!

sixxNameAttribString: idString
	^'sixx.name="' , idString asString , '" '!

sixxOn: aStream
	self 
		sixxOn: aStream
		indent: 0
		context: IdentityDictionary new!

sixxOn: aStream indent: level context: dictionary
	^self 
		sixxOn: aStream
		name: nil
		indent: level
		context: dictionary!

sixxOn: aStream name: nameString indent: level context: dictionary
	aStream tab: level.
	(dictionary includesKey: self) 
		ifTrue: 
			[aStream nextPutAll: (self sixxRefTagStartString: (dictionary at: self) name: nameString)]
		ifFalse: 
			[| idStr |
			idStr := dictionary size printString.
			dictionary at: self put: idStr.
			aStream nextPutAll: (self sixxTagStartString: idStr name: nameString).
			self 
				sixxContentOn: aStream
				indent: level
				context: dictionary].
	aStream nextPutAll: self sixxTagEndString.
	aStream cr!

sixxRefTagStartString: idString
	| wStr |
	wStr := (String new: 16) writeStream.
	wStr nextPutAll: '<sixx.object sixx.idref="'.
	idString isNil ifFalse: [wStr nextPutAll: idString].
	wStr nextPutAll: '" >'.
	^wStr contents!

sixxRefTagStartString: idString name: nameString
	| wStr |
	wStr := (String new: 16) writeStream.
	wStr nextPutAll: '<sixx.object sixx.idref="'.
	wStr nextPutAll: idString.
	wStr nextPutAll: '" '.
	nameString notNil 
		ifTrue: 
			[wStr nextPutAll: 'sixx.name="'.
			wStr nextPutAll: nameString.
			wStr nextPutAll: '" '].
	wStr nextPutAll: '>'.
	^wStr contents!

sixxString
	| wStr |
	wStr := (String new: 128) writeStream.
	self sixxOn: wStr.
	^wStr contents!

sixxTagEndString
	| wStr |
	wStr := (String new: 16) writeStream.
	wStr nextPutAll: '</sixx.object>'.
	^wStr contents!

sixxTagStartString: idString name: nameString
	| wStr |
	wStr := (String new: 16) writeStream.
	wStr nextPutAll: '<sixx.object '.
	idString isNil ifFalse: [wStr nextPutAll: (self sixxIdAttribString: idString)].
	nameString isNil ifFalse: [wStr nextPutAll: (self sixxNameAttribString: nameString)].
	wStr nextPutAll: self sixxTypeAttribString.
	SixxSetting useEnvironment ifTrue: [wStr nextPutAll: self sixxEnvAttribString].
	wStr nextPutAll: '>'.
	^wStr contents!

sixxType
	^self class name!

sixxTypeAttribString
	^'sixx.type="' , self sixxType , '" '! !
!Object categoriesFor: #initializeFromSixxElement:context:!initializing-sixx!public! !
!Object categoriesFor: #initializeIndexFieldsFromSixxElement:context:!initializing-sixx!public! !
!Object categoriesFor: #initializeInstVarsFromSixxElement:context:!initializing-sixx!public! !
!Object categoriesFor: #initializeMixedFieldsFromSixxElement:context:!initializing-sixx!public! !
!Object categoriesFor: #sixxAt:put:!initializing-sixx!public! !
!Object categoriesFor: #sixxChildrenContentsOn:indent:context:!private-sixx!public! !
!Object categoriesFor: #sixxContentOn:indent:context:!printing-sixx!public! !
!Object categoriesFor: #sixxEnv!private-sixx!public! !
!Object categoriesFor: #sixxEnvAttribString!private-sixx!public! !
!Object categoriesFor: #sixxIdAttribString:!actions-parse!private! !
!Object categoriesFor: #sixxIndexFieldsOn:indent:context:!private-sixx!public! !
!Object categoriesFor: #sixxInitialize!initializing-sixx!public! !
!Object categoriesFor: #sixxInstVarNamed:put:!initializing-sixx!public! !
!Object categoriesFor: #sixxInstVarsOn:indent:context:!private-sixx!public! !
!Object categoriesFor: #sixxMixedFieldsOn:indent:context:!private-sixx!public! !
!Object categoriesFor: #sixxNameAttribString:!actions-parse!private! !
!Object categoriesFor: #sixxOn:!printing-sixx!public! !
!Object categoriesFor: #sixxOn:indent:context:!printing-sixx!public! !
!Object categoriesFor: #sixxOn:name:indent:context:!printing-sixx!public! !
!Object categoriesFor: #sixxRefTagStartString:!actions-parse!private! !
!Object categoriesFor: #sixxRefTagStartString:name:!actions-parse!private! !
!Object categoriesFor: #sixxString!printing-sixx!public! !
!Object categoriesFor: #sixxTagEndString!actions-parse!private! !
!Object categoriesFor: #sixxTagStartString:name:!private-sixx!public! !
!Object categoriesFor: #sixxType!actions-parse!private! !
!Object categoriesFor: #sixxTypeAttribString!actions-parse!private! !

!Point methodsFor!

sixxContentOn: aStream indent: level context: dictionary 
	aStream nextPutAll: x printString.
	aStream nextPut: $@.
	aStream nextPutAll: y printString! !
!Point categoriesFor: #sixxContentOn:indent:context:!printing-sixx!public! !

!Point class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement 
	| readStr x y |
	readStr := ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement).
	x := (readStr upTo: $@) asNumber.
	y := readStr upToEnd asNumber.
	^self x: x y: y! !
!Point class categoriesFor: #createInstanceOf:withSixxElement:!instance creation-sixx!public! !

!RunArray methodsFor!

initializeFromSixxElement: sixxElement context: aDictionary
	(SixxXmlUtil elementsFrom: sixxElement) do: 
			[:elem | 
			| varName |
			(SixxXmlUtil isTextFrom: elem) 
				ifFalse: 
					[varName := self class nameFromSixxElement: elem.
					varName notNil 
						ifTrue: 
							[| childInst |
							childInst := self class fromSixxElement: elem context: aDictionary.
							self sixxInstVarNamed: varName put: childInst]]]!

sixxContentOn: aStream indent: level context: dictionary
	aStream cr.
	self runs 
		sixxOn: aStream
		name: 'runs'
		indent: level + 1
		context: dictionary.
	self values 
		sixxOn: aStream
		name: 'values'
		indent: level + 1
		context: dictionary.
	aStream tab: level! !
!RunArray categoriesFor: #initializeFromSixxElement:context:!initializing-sixx!printing-sixx!public! !
!RunArray categoriesFor: #sixxContentOn:indent:context:!printing-sixx!public! !

!String methodsFor!

sixxContentOn: aStream indent: level context: dictionary
	SixxXmlUtil writeXmlText: self on: aStream! !
!String categoriesFor: #sixxContentOn:indent:context:!printing-sixx!public! !

!String class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement
	^SixxXmlUtil characterDataFrom: sixxElement! !
!String class categoriesFor: #createInstanceOf:withSixxElement:!instance creation-sixx!public! !

!Symbol class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement
	^(super createInstanceOf: aClass withSixxElement: sixxElement) asSymbol! !
!Symbol class categoriesFor: #createInstanceOf:withSixxElement:!instance creation-sixx!public! !

!Time methodsFor!

sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self sixxContentString! !
!Time categoriesFor: #sixxContentOn:indent:context:!printing-sixx!public! !

!Time class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement
	^self readSixxContentStringFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement))! !
!Time class categoriesFor: #createInstanceOf:withSixxElement:!instance creation-sixx!public! !

!UndefinedObject methodsFor!

asSixxKey
	"For some Smalltalks which do not support nil key in IdentityDictionary"

	^#'SIXX-UndefinedObject(98ea8c30-2bf8-4d23-9da2-ad1ee0e29eff)'!

sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self storeString!

sixxOn: aStream name: nameString indent: level context: dictionary
	| key |
	key := self asSixxKey.
	aStream tab: level.
	(dictionary includesKey: key) 
		ifTrue: 
			[aStream 
				nextPutAll: (self sixxRefTagStartString: (dictionary at: key) name: nameString)]
		ifFalse: 
			[| idStr |
			idStr := dictionary size printString.
			dictionary at: key put: idStr.
			aStream nextPutAll: (self sixxTagStartString: idStr name: nameString).
			self 
				sixxContentOn: aStream
				indent: level
				context: dictionary].
	aStream nextPutAll: self sixxTagEndString.
	aStream cr! !
!UndefinedObject categoriesFor: #asSixxKey!private!private-sixx! !
!UndefinedObject categoriesFor: #sixxContentOn:indent:context:!printing-sixx!public! !
!UndefinedObject categoriesFor: #sixxOn:name:indent:context:!printing-sixx!public! !

!UndefinedObject class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement
	^self readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement))! !
!UndefinedObject class categoriesFor: #createInstanceOf:withSixxElement:!instance creation-sixx!public! !

"End of package definition"!

"Source Globals"!

"Classes"!

"Binary Globals"!

"Resources"!

