| package |
package := Package name: 'SIXX-Tests'.
package paxVersion: 0;
	basicComment: ''.


package classNames
	add: #SixxAbstractTestCase;
	add: #SixxConstantsTestCase;
	add: #SixxGeneratingTestCase;
	add: #SixxLoadingTestCase;
	add: #SixxMockBinaryData;
	add: #SixxMockClassForUnitTest;
	add: #SixxMockEnvelope;
	add: #SixxMockFixedAlternativeClass;
	add: #SixxMockFixedNewFailedClass;
	add: #SixxMockHeader;
	add: #SixxMockSuperClassForUnitTest;
	add: #SixxMockVariableAlternativeClass;
	add: #SixxMockVariableNewFailedClass;
	add: #SixxNamespaceSupportTestCase;
	add: #SixxNewFailedTestCase;
	add: #SixxReadStreamTestCase;
	add: #SixxWriteStreamTestCase;
	add: #SixxXmlParserTestCase;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package allResourceNames: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\Object Arts\Dolphin\MVP\Base\Dolphin MVP Base';
	add: 'SIXX-Core';
	add: 'SIXX-InOut-Dolphin';
	add: 'SIXX-ParserAdapter';
	add: '..\Camp Smalltalk\SUnit\SUnit';
	yourself).

package!

"Class Definitions"!

Object variableSubclass: #SixxMockBinaryData
	instanceVariableNames: 'author version'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #SixxMockEnvelope
	instanceVariableNames: 'header'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #SixxMockFixedNewFailedClass
	instanceVariableNames: 'att1 att2 att3Block'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #SixxMockHeader
	instanceVariableNames: 'id'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #SixxMockSuperClassForUnitTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: 'instVar1 instVar2'!
Array variableSubclass: #SixxMockVariableNewFailedClass
	instanceVariableNames: 'att1 att2 att3Block'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SixxMockVariableNewFailedClass variableSubclass: #SixxMockVariableAlternativeClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SixxMockFixedNewFailedClass subclass: #SixxMockFixedAlternativeClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SixxMockSuperClassForUnitTest subclass: #SixxMockClassForUnitTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: 'instVar3'!
TestCase subclass: #SixxAbstractTestCase
	instanceVariableNames: 'originalUseEnvironment'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SixxAbstractTestCase subclass: #SixxConstantsTestCase
	instanceVariableNames: 'oldSixxConstants'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SixxAbstractTestCase subclass: #SixxGeneratingTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SixxAbstractTestCase subclass: #SixxLoadingTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SixxAbstractTestCase subclass: #SixxNamespaceSupportTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SixxAbstractTestCase subclass: #SixxNewFailedTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SixxAbstractTestCase subclass: #SixxReadStreamTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SixxAbstractTestCase subclass: #SixxWriteStreamTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SixxAbstractTestCase subclass: #SixxXmlParserTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

"End of package definition"!

"Source Globals"!

"Classes"!

SixxMockBinaryData guid: (GUID fromString: '{ECD1792E-2B75-4AF4-8E3C-AEDD60196BD0}')!
SixxMockBinaryData comment: ''!
!SixxMockBinaryData categoriesForClass!Kernel-Objects! !
!SixxMockBinaryData methodsFor!

author
	^author!

author: aString
	author := aString!

version
	^version!

version: aString
	version := aString! !
!SixxMockBinaryData categoriesFor: #author!accessing!public! !
!SixxMockBinaryData categoriesFor: #author:!accessing!public! !
!SixxMockBinaryData categoriesFor: #version!accessing!public! !
!SixxMockBinaryData categoriesFor: #version:!accessing!public! !

!SixxMockBinaryData class methodsFor!

author: author version: version data: binaryData
	"SixxMockBinaryData author: 'MU' version: '0.1' data: #(1 2 3)"

	| inst idx |
	inst := self new: binaryData size.
	idx := 0.
	binaryData do: [:each | inst at: (idx := idx + 1) put: each].
	inst author: author.
	inst version: version.
	^inst! !
!SixxMockBinaryData class categoriesFor: #author:version:data:!instance creation!public! !

SixxMockEnvelope guid: (GUID fromString: '{CA7B9705-1E4B-42A6-8CF2-D3D868B7DDD5}')!
SixxMockEnvelope comment: ''!
!SixxMockEnvelope categoriesForClass!Kernel-Objects! !
!SixxMockEnvelope methodsFor!

header
	^header!

header: aHeader
	header := aHeader! !
!SixxMockEnvelope categoriesFor: #header!accessing!public! !
!SixxMockEnvelope categoriesFor: #header:!accessing!public! !

!SixxMockEnvelope class methodsFor!

header: aHeader
	super initialize.
	^self new header: aHeader! !
!SixxMockEnvelope class categoriesFor: #header:!instance creation!public! !

SixxMockFixedNewFailedClass guid: (GUID fromString: '{9DA5F8C6-9405-418A-B032-5CE1FC314D69}')!
SixxMockFixedNewFailedClass comment: ''!
!SixxMockFixedNewFailedClass categoriesForClass!Kernel-Objects! !
!SixxMockFixedNewFailedClass methodsFor!

att1
	^att1!

att1: aValue 
	att1 := aValue!

att2
	^att2!

att2: aValue 
	att2 := aValue!

att3Block
	^att3Block!

att3Block: aValue 
	att3Block := aValue!

sixxInitialize
	att3Block := [:a :b | a < b]! !
!SixxMockFixedNewFailedClass categoriesFor: #att1!accessing!public! !
!SixxMockFixedNewFailedClass categoriesFor: #att1:!accessing!public! !
!SixxMockFixedNewFailedClass categoriesFor: #att2!accessing!public! !
!SixxMockFixedNewFailedClass categoriesFor: #att2:!accessing!public! !
!SixxMockFixedNewFailedClass categoriesFor: #att3Block!accessing!public! !
!SixxMockFixedNewFailedClass categoriesFor: #att3Block:!accessing!public! !
!SixxMockFixedNewFailedClass categoriesFor: #sixxInitialize!initializing-sixx!public! !

!SixxMockFixedNewFailedClass class methodsFor!

new
	^Error new signal: '#new should not be used!!'!

prototype1
	"self prototype1"

	| inst |
	inst := self basicNew.
	inst att1: 1.
	inst att2: 'TWO'.
	inst att3Block: [:this | 'is block'].
	^inst!

prototype2
	"self prototype2"

	| inst |
	inst := self basicNew.
	inst att1: 3.
	inst att2: 'Four'.
	inst att3Block: [:this :is | 'block2'].
	^inst! !
!SixxMockFixedNewFailedClass class categoriesFor: #new!instance creation!public! !
!SixxMockFixedNewFailedClass class categoriesFor: #prototype1!instance creation!public! !
!SixxMockFixedNewFailedClass class categoriesFor: #prototype2!instance creation!public! !

SixxMockHeader guid: (GUID fromString: '{D92516BD-62E0-4988-BDB0-19063E011F91}')!
SixxMockHeader comment: ''!
!SixxMockHeader categoriesForClass!Kernel-Objects! !
!SixxMockHeader methodsFor!

id
	^id!

id: aString
	id := aString! !
!SixxMockHeader categoriesFor: #id!accessing!public! !
!SixxMockHeader categoriesFor: #id:!accessing!public! !

!SixxMockHeader class methodsFor!

id: aString
	^self new id: aString! !
!SixxMockHeader class categoriesFor: #id:!instance creation!public! !

SixxMockSuperClassForUnitTest guid: (GUID fromString: '{96275E14-E840-43BE-A9A1-BF5D77A77B0A}')!
SixxMockSuperClassForUnitTest comment: ''!
!SixxMockSuperClassForUnitTest categoriesForClass!Kernel-Objects! !
!SixxMockSuperClassForUnitTest class methodsFor!

initialize
	"MockSuperClassForUnitTest initialize"

	super initialize.
	instVar1 := nil.
	instVar2 := nil!

instVar1
	instVar1 isNil ifTrue: [instVar1 := ''].
	^instVar1!

instVar1: aString
	instVar1 := aString!

instVar2
	instVar2 isNil ifTrue: [instVar2 := ''].
	^instVar2!

instVar2: aString
	instVar2 := aString! !
!SixxMockSuperClassForUnitTest class categoriesFor: #initialize!class initialization!public! !
!SixxMockSuperClassForUnitTest class categoriesFor: #instVar1!accessing!public! !
!SixxMockSuperClassForUnitTest class categoriesFor: #instVar1:!accessing!public! !
!SixxMockSuperClassForUnitTest class categoriesFor: #instVar2!accessing!public! !
!SixxMockSuperClassForUnitTest class categoriesFor: #instVar2:!accessing!public! !

SixxMockVariableNewFailedClass guid: (GUID fromString: '{488F505C-504A-440F-B2BA-8072CC304672}')!
SixxMockVariableNewFailedClass comment: ''!
!SixxMockVariableNewFailedClass categoriesForClass!Collections-Arrayed! !
!SixxMockVariableNewFailedClass methodsFor!

att1
	^att1!

att1: aValue 
	att1 := aValue!

att2
	^att2!

att2: aValue 
	att2 := aValue!

att3Block
	^att3Block!

att3Block: aValue 
	att3Block := aValue!

initializeFromSixxElement: sixxElement context: aDictionary 
	self initializeMixedFieldsFromSixxElement: sixxElement context: aDictionary!

sixxContentOn: aStream indent: level context: dictionary 
	"override if you like"

	self 
		sixxInstVarsOn: aStream
		indent: level
		context: dictionary.
	self 
		sixxIndexFieldsOn: aStream
		indent: level
		context: dictionary!

sixxInitialize
	att3Block := [:a :b | a < b]! !
!SixxMockVariableNewFailedClass categoriesFor: #att1!accessing!public! !
!SixxMockVariableNewFailedClass categoriesFor: #att1:!accessing!public! !
!SixxMockVariableNewFailedClass categoriesFor: #att2!accessing!public! !
!SixxMockVariableNewFailedClass categoriesFor: #att2:!accessing!public! !
!SixxMockVariableNewFailedClass categoriesFor: #att3Block!accessing!public! !
!SixxMockVariableNewFailedClass categoriesFor: #att3Block:!accessing!public! !
!SixxMockVariableNewFailedClass categoriesFor: #initializeFromSixxElement:context:!initializing-sixx!public! !
!SixxMockVariableNewFailedClass categoriesFor: #sixxContentOn:indent:context:!private-sixx!public! !
!SixxMockVariableNewFailedClass categoriesFor: #sixxInitialize!initializing-sixx!public! !

!SixxMockVariableNewFailedClass class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement 
	^self createMixedFieldsInstanceOf: aClass withSixxElement: sixxElement!

new: size 
	Error new signal: '#new: should not be called'!

prototype1
	"self prototype1"

	| inst |
	inst := self basicNew: 3.
	1 to: 3 do: [:idx | inst at: idx put: idx printString].
	inst att1: 1.
	inst att2: 'TWO'.
	inst att3Block: [:this | 'is block'].
	^inst!

prototype2
	"self prototype2"

	| inst |
	inst := self basicNew: 3.
	1 to: 3 do: [:idx | inst at: idx put: idx printString].
	inst att1: 3.
	inst att2: 'Four'.
	inst att3Block: [:this :is | 'block2'].
	^inst! !
!SixxMockVariableNewFailedClass class categoriesFor: #createInstanceOf:withSixxElement:!instance creation-sixx!public! !
!SixxMockVariableNewFailedClass class categoriesFor: #new:!instance creation!public! !
!SixxMockVariableNewFailedClass class categoriesFor: #prototype1!for tests!public! !
!SixxMockVariableNewFailedClass class categoriesFor: #prototype2!for tests!public! !

SixxMockVariableAlternativeClass guid: (GUID fromString: '{1E6CCF71-5B24-46B2-8A7E-405AE876DC61}')!
SixxMockVariableAlternativeClass comment: ''!
!SixxMockVariableAlternativeClass categoriesForClass!Collections-Arrayed! !
!SixxMockVariableAlternativeClass class methodsFor!

new: size 
	"new: is OK for me"

	^self basicNew: size! !
!SixxMockVariableAlternativeClass class categoriesFor: #new:!instance creation!public! !

SixxMockFixedAlternativeClass guid: (GUID fromString: '{373920F7-3486-4069-B4FF-ABC7DD2C1074}')!
SixxMockFixedAlternativeClass comment: ''!
!SixxMockFixedAlternativeClass categoriesForClass!Kernel-Objects! !
!SixxMockFixedAlternativeClass class methodsFor!

new
	"new is OK for me"

	^self basicNew! !
!SixxMockFixedAlternativeClass class categoriesFor: #new!instance creation!public! !

SixxMockClassForUnitTest guid: (GUID fromString: '{5FFA7827-0498-4AB9-BF1C-D28A4BA1CA1F}')!
SixxMockClassForUnitTest comment: ''!
!SixxMockClassForUnitTest categoriesForClass!Kernel-Objects! !
!SixxMockClassForUnitTest class methodsFor!

initialize
	"MockClassForUnitTest initialize"

	super initialize.
	instVar3 := nil!

instVar3
	instVar3 isNil ifTrue: [instVar3 := ''].
	^instVar3!

instVar3: aString
	instVar3 := aString! !
!SixxMockClassForUnitTest class categoriesFor: #initialize!accessing!class initialization!public! !
!SixxMockClassForUnitTest class categoriesFor: #instVar3!accessing!public! !
!SixxMockClassForUnitTest class categoriesFor: #instVar3:!accessing!public! !

SixxAbstractTestCase guid: (GUID fromString: '{0B1493D9-EC5A-4D33-9A41-CB5D52CE6739}')!
SixxAbstractTestCase comment: ''!
!SixxAbstractTestCase categoriesForClass!SUnit! !
!SixxAbstractTestCase methodsFor!

setUp
	originalUseEnvironment := SixxSetting useEnvironment.
	SixxSetting useEnvironment: false!

tearDown
	SixxSetting useEnvironment: originalUseEnvironment! !
!SixxAbstractTestCase categoriesFor: #setUp!private!running! !
!SixxAbstractTestCase categoriesFor: #tearDown!private!running! !

SixxConstantsTestCase guid: (GUID fromString: '{B5C27D71-9720-4B0D-A826-9411E7A9CCEC}')!
SixxConstantsTestCase comment: ''!
!SixxConstantsTestCase categoriesForClass!SUnit! !
!SixxConstantsTestCase methodsFor!

oldSixxConstants
	^ oldSixxConstants!

oldSixxConstants: aSixxConstants
	oldSixxConstants := aSixxConstants!

setUp
	^self oldSixxConstants: SixxConstants!

tearDown
	SixxConstants initialize.
	SixxConstants xmlVersion: self oldSixxConstants xmlVersion.
	SixxConstants xmlEncoding: self oldSixxConstants xmlEncoding.
	SixxConstants sixxVersion: self oldSixxConstants sixxVersion!

testInitialize
	SixxConstants initialize.
	self should: [SixxConstants xmlVersion = '1.0'].
	self should: [SixxConstants xmlEncoding = 'utf-8'].
	self should: [SixxConstants sixxVersion = '1.0']!

testSixxStartTag
	SixxConstants initialize.
	self should: [SixxConstants sixxStartTag = '<sixx sixx.version="1.0">'].
	SixxConstants sixxVersion: '2.0'.
	self should: [SixxConstants sixxStartTag = '<sixx sixx.version="2.0">']!

testXmlDeclaration
	SixxConstants initialize.
	self should: [SixxConstants xmlDeclaration = '<?xml version="1.0" encoding="utf-8"?>'].
	SixxConstants xmlVersion: '3.0'.
	SixxConstants xmlEncoding: 'sjis'.
	self should: [SixxConstants xmlDeclaration = '<?xml version="3.0" encoding="sjis"?>']! !
!SixxConstantsTestCase categoriesFor: #oldSixxConstants!accessing!private! !
!SixxConstantsTestCase categoriesFor: #oldSixxConstants:!accessing!private! !
!SixxConstantsTestCase categoriesFor: #setUp!private!running! !
!SixxConstantsTestCase categoriesFor: #tearDown!private!running! !
!SixxConstantsTestCase categoriesFor: #testInitialize!public!tests! !
!SixxConstantsTestCase categoriesFor: #testSixxStartTag!public!tests! !
!SixxConstantsTestCase categoriesFor: #testXmlDeclaration!public!tests! !

SixxGeneratingTestCase guid: (GUID fromString: '{12F09600-F2E2-4783-BCD2-B3BEE9218957}')!
SixxGeneratingTestCase comment: ''!
!SixxGeneratingTestCase categoriesForClass!SUnit! !
!SixxGeneratingTestCase methodsFor!

testSixxStringForArray
	| arr expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Array" >
	<sixx.object sixx.id="1" sixx.type="SmallInteger" >10</sixx.object>
	<sixx.object sixx.id="2" sixx.type="SmallInteger" >20</sixx.object>
	<sixx.object sixx.id="3" sixx.type="SmallInteger" >30</sixx.object>
</sixx.object>
'.
	arr := Array new: 3.
	arr at: 1 put: 10.
	arr at: 2 put: 20.
	arr at: 3 put: 30.
	self should: [arr sixxString = expectedStr]!

testSixxStringForBag
	| bag result |
	bag := Bag new.
	bag add: 10.
	bag add: 20.
	bag add: 30.
	bag add: 30.
	result := Object readSixxFrom: bag sixxString.
	self should: [result size = 4].
	self should: [result includes: 10].
	self should: [result includes: 20].
	self should: [result includes: 30].
	self should: [(result occurrencesOf: 30) = 2]!

testSixxStringForBoolean
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="True" >true</sixx.object>
'.
	self should: [true sixxString = expectedStr]!

testSixxStringForByteArray
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="ByteArray" >0A141E</sixx.object>
'.
	self 
		should: [(ByteArray 
				with: 10
				with: 20
				with: 30) sixxString = expectedStr]!

testSixxStringForCharacter
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Character" >$A</sixx.object>
'.
	self should: [$A sixxString = expectedStr]!

testSixxStringForClass
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="SixxMockClassForUnitTest class" >
	<sixx.object sixx.id="1" sixx.name="instVar1" sixx.type="String" >value1</sixx.object>
	<sixx.object sixx.id="2" sixx.name="instVar2" sixx.type="String" >value2</sixx.object>
	<sixx.object sixx.id="3" sixx.name="instVar3" sixx.type="String" >value3</sixx.object>
</sixx.object>
'.
	SixxMockClassForUnitTest instVar1: 'value1'.
	SixxMockClassForUnitTest instVar2: 'value2'.
	SixxMockClassForUnitTest instVar3: 'value3'.
	self should: [SixxMockClassForUnitTest sixxString = expectedStr]!

testSixxStringForColor
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Color" >(Color r: 0.0 g: 0.0 b: 1.0)</sixx.object>
'.
	self
		should: [SixxColor blue sixxString = expectedStr]!

testSixxStringForCompositeDictionary
	| dic childDic expected |
	expected := '<sixx.object sixx.id="0" sixx.type="Dictionary" >
	<sixx.object sixx.id="1" sixx.type="Association" >
		<sixx.object sixx.id="2" sixx.name="key" sixx.type="Symbol" >parent2</sixx.object>
		<sixx.object sixx.id="3" sixx.name="value" sixx.type="SmallInteger" >100</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.type="Association" >
		<sixx.object sixx.id="5" sixx.name="key" sixx.type="Symbol" >parent1</sixx.object>
		<sixx.object sixx.id="6" sixx.name="value" sixx.type="String" >sample string.</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="7" sixx.type="Association" >
		<sixx.object sixx.id="8" sixx.name="key" sixx.type="Symbol" >parent4</sixx.object>
		<sixx.object sixx.id="9" sixx.name="value" sixx.type="Dictionary" >
			<sixx.object sixx.id="10" sixx.type="Association" >
				<sixx.object sixx.id="11" sixx.name="key" sixx.type="Symbol" >child1</sixx.object>
				<sixx.object sixx.id="12" sixx.name="value" sixx.type="String" >abcde</sixx.object>
			</sixx.object>
		</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="13" sixx.type="Association" >
		<sixx.object sixx.id="14" sixx.name="key" sixx.type="Symbol" >parent3</sixx.object>
		<sixx.object sixx.id="15" sixx.name="value" sixx.type="Array" >
			<sixx.object sixx.id="16" sixx.type="SmallInteger" >10</sixx.object>
			<sixx.object sixx.id="17" sixx.type="SmallInteger" >20</sixx.object>
			<sixx.object sixx.id="18" sixx.type="SmallInteger" >30</sixx.object>
		</sixx.object>
	</sixx.object>
</sixx.object>
'.
	childDic := Dictionary new.
	childDic at: #child1 put: 'abcde'.
	dic := Dictionary new.
	dic at: #parent1 put: 'sample string.'.
	dic at: #parent2 put: 100.
	dic at: #parent3 put: #(10 20 30).
	dic at: #parent4 put: childDic.
	self should: 
			[((Object readSixxFrom: dic sixxString) at: #parent1) 
				= ((Object readSixxFrom: expected) at: #parent1)].
	self should: 
			[((Object readSixxFrom: dic sixxString) at: #parent2) 
				= ((Object readSixxFrom: expected) at: #parent2)].
	self should: 
			[((Object readSixxFrom: dic sixxString) at: #parent3) 
				= ((Object readSixxFrom: expected) at: #parent3)].
	self should: 
			[((Object readSixxFrom: dic sixxString) at: #parent4) 
				equals: ((Object readSixxFrom: expected) at: #parent4)]!

testSixxStringForDate
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Date" >14 May 2002</sixx.object>
'.
	self should: 
			[(Date 
				newDay: 14
				monthNumber: 5
				year: 2002) sixxString = expectedStr]!

testSixxStringForDictionary
	| dic expected |
	expected := '<sixx.object sixx.id="0" sixx.type="Dictionary" >
	<sixx.object sixx.id="1" sixx.type="Association" >
		<sixx.object sixx.id="2" sixx.name="key" sixx.type="Symbol" >key2</sixx.object>
		<sixx.object sixx.id="3" sixx.name="value" sixx.type="String" >value2</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.type="Association" >
		<sixx.object sixx.id="5" sixx.name="key" sixx.type="Symbol" >key1</sixx.object>
		<sixx.object sixx.id="6" sixx.name="value" sixx.type="String" >value1</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="7" sixx.type="Association" >
		<sixx.object sixx.id="8" sixx.name="key" sixx.type="Symbol" >key3</sixx.object>
		<sixx.object sixx.id="9" sixx.name="value" sixx.type="String" >value3</sixx.object>
	</sixx.object>
</sixx.object>
'.
	dic := Dictionary new.
	dic at: #key1 put: 'value1'.
	dic at: #key2 put: 'value2'.
	dic at: #key3 put: 'value3'.
	self 
		should: [(Object readSixxFrom: dic sixxString) equals: (Object readSixxFrom: expected)]!

testSixxStringForIndexedColor
	"Dolphin Specific"
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="IndexedColor" >(IndexedColor stdColor: #blue)</sixx.object>
'.
	self should: [Color blue sixxString = expectedStr]!

testSixxStringForInterval
	| interval expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Interval" >(1 to: 10 by: 3)</sixx.object>
'.
	interval := 1 to: 10 by: 3.
	self should: [interval sixxString = expectedStr]!

testSixxStringForNumber
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Fraction" >(3/4)</sixx.object>
'.
	self should: [(3 / 4) sixxString = expectedStr]!

testSixxStringForOrdredCollection
	| expectedStr col |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="OrderedCollection" >
	<sixx.object sixx.id="1" sixx.type="SmallInteger" >10</sixx.object>
	<sixx.object sixx.id="2" sixx.type="SmallInteger" >20</sixx.object>
	<sixx.object sixx.id="3" sixx.type="SmallInteger" >30</sixx.object>
</sixx.object>
'.
	col := OrderedCollection new.
	col add: 10.
	col add: 20.
	col add: 30.
	self should: [col sixxString = expectedStr]!

testSixxStringForRGB
	"Dolphin Specific"

	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="RGB" >16711680</sixx.object>
'.
	self should: [RGB blue sixxString = expectedStr]!

testSixxStringForRunArray
	| arr expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="RunArray" >
	<sixx.object sixx.id="1" sixx.name="runs" sixx.type="Array" >
		<sixx.object sixx.id="2" sixx.type="SmallInteger" >1</sixx.object>
		<sixx.object sixx.id="3" sixx.type="SmallInteger" >2</sixx.object>
		<sixx.object sixx.idref="2" ></sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.name="values" sixx.type="Array" >
		<sixx.object sixx.idref="2" ></sixx.object>
		<sixx.object sixx.idref="3" ></sixx.object>
		<sixx.object sixx.id="5" sixx.type="SmallInteger" >3</sixx.object>
	</sixx.object>
</sixx.object>
'.
	arr := RunArray runs: #(1 2 1) values: #(1 2 3).
	self should: [arr sixxString = expectedStr]!

testSixxStringForSet
	| set result |
	set := Set new.
	set add: 10.
	set add: 20.
	set add: 30.
	set add: 30.
	result := Object readSixxFrom: set sixxString.
	self should: [result size = 3].
	self should: [result includes: 10].
	self should: [result includes: 20].
	self should: [result includes: 30]!

testSixxStringForSimpleObject
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Object" >
</sixx.object>
'.
	self should: [Object new sixxString = expectedStr]!

testSixxStringForString
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="String" >Hi&#44; I&apos;m String-object</sixx.object>
'.
	self should: ['Hi, I''m String-object' sixxString = expectedStr]!

testSixxStringForStringUsingCDATA
	| originalSetting expectedStr |
	
	[originalSetting := SixxSetting useCDATA.
	SixxSetting useCDATA: true.
	expectedStr := '<sixx.object sixx.id="0" sixx.type="String" ><!![CDATA[Hi, I''m String-object.
How are you?
]]></sixx.object>
'.
	self should: ['Hi, I''m String-object.
How are you?
' sixxString = expectedStr]] 
			ensure: [SixxSetting useCDATA: originalSetting]!

testSixxStringForTime
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Time" >' 
				, (Time readFrom: '1:30:59 pm' readStream) sixxContentString , '</sixx.object>
'.
	self 
		should: [(Time readFrom: '1:30:59 pm' readStream) sixxString = expectedStr]!

testSixxStringForUndefinedObject
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="UndefinedObject" >nil</sixx.object>
'.
	self should: [nil sixxString = expectedStr]!

testSixxStringForVariableObject
	| expectedStr variableObj |
	expectedStr := 
'<sixx.object sixx.id="0" sixx.type="SixxMockBinaryData" >
	<sixx.object sixx.id="1" sixx.name="author" sixx.type="String" >MU</sixx.object>
	<sixx.object sixx.id="2" sixx.name="version" sixx.type="String" >0.1</sixx.object>
	<sixx.object sixx.id="3" sixx.type="SmallInteger" >1</sixx.object>
	<sixx.object sixx.id="4" sixx.type="SmallInteger" >2</sixx.object>
	<sixx.object sixx.id="5" sixx.type="SmallInteger" >3</sixx.object>
</sixx.object>
'.
	variableObj := SixxMockBinaryData 
				author: 'MU'
				version: '0.1'
				data: #(1 2 3).
	self should: [variableObj sixxString = expectedStr]!

testSixxStringForVariableObjectNoData
	| expectedStr variableObj |
	
	expectedStr := '<sixx.object sixx.id="0" sixx.type="SixxMockBinaryData" >
	<sixx.object sixx.id="1" sixx.name="author" sixx.type="String" >MU</sixx.object>
	<sixx.object sixx.id="2" sixx.name="version" sixx.type="String" >0.1</sixx.object>
</sixx.object>
'.

	variableObj := SixxMockBinaryData author: 'MU' version: '0.1' data: #().
	self
		should: [variableObj sixxString = expectedStr].! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForArray!public!tests! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForBag!public!tests! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForBoolean!public!tests! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForByteArray!public!tests! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForCharacter!public!tests! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForClass!public!tests! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForColor!public!tests! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForCompositeDictionary!public!tests! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForDate!public!tests! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForDictionary!public!tests! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForIndexedColor!public!tests! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForInterval!public!tests! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForNumber!public!tests! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForOrdredCollection!public!tests! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForRGB!public!tests! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForRunArray!public!tests! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForSet!public!tests! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForSimpleObject!public!tests! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForString!public!tests! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForStringUsingCDATA!public!tests! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForTime!public!tests! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForUndefinedObject!public!tests! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForVariableObject!public!tests! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForVariableObjectNoData!public!tests! !

SixxLoadingTestCase guid: (GUID fromString: '{EB302298-D3E5-4989-B80D-8E5BD16A056F}')!
SixxLoadingTestCase comment: ''!
!SixxLoadingTestCase categoriesForClass!SUnit! !
!SixxLoadingTestCase methodsFor!

testReadSixxForArray
	| sixxString arr |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Array" >
	<sixx.object sixx.id="1" sixx.type="SmallInteger" >10</sixx.object>
	<sixx.object sixx.id="2" sixx.type="SmallInteger" >20</sixx.object>
	<sixx.object sixx.id="3" sixx.type="SmallInteger" >30</sixx.object>
</sixx.object>
'.
	arr := Object readSixxFrom: sixxString.
	self should: [arr size = 3].
	self should: [(arr at: 1) = 10].
	self should: [(arr at: 2) = 20].
	self should: [(arr at: 3) = 30]!

testReadSixxForBag
	| sixxString bag |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Bag" >
	<sixx.object sixx.id="1" sixx.type="String" >abcd</sixx.object>
	<sixx.object sixx.id="2" sixx.type="SmallInteger" >10</sixx.object>
	<sixx.object sixx.idref="2" ></sixx.object>
	<sixx.object sixx.id="3" sixx.type="Array" >
		<sixx.object sixx.idref="2" ></sixx.object>
		<sixx.object sixx.id="4" sixx.type="SmallInteger" >20</sixx.object>
	</sixx.object>
</sixx.object>
'.
	bag := Object readSixxFrom: sixxString.
	self should: [bag size = 4].
	self should: [(bag occurrencesOf: 10) = 2].
	self should: [(bag occurrencesOf: 'abcd') = 1].
	self should: [(bag occurrencesOf: #(10 20)) = 1]!

testReadSixxForBoolean
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="True" >true</sixx.object>
'.
	self should: [(Object readSixxFrom: sixxString) = true]!

testReadSixxForByteArray
	| sixxString byteArr |
	sixxString := '<sixx.object sixx.id="0" sixx.type="ByteArray" >0A141E</sixx.object>
'.
	byteArr := Object readSixxFrom: sixxString.
	self should: [byteArr size = 3].
	self should: [(byteArr at: 1) = 10].
	self should: [(byteArr at: 2) = 20].
	self should: [(byteArr at: 3) = 30]!

testReadSixxForCharacter
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Character" >$A</sixx.object>
'.
	self should: [(Object readSixxFrom: sixxString) = $A]!

testReadSixxForClass
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="SixxMockClassForUnitTest class" >
	<sixx.object sixx.id="1" sixx.name="instVar1" sixx.type="SmallInteger" >10</sixx.object>
	<sixx.object sixx.id="2" sixx.name="instVar2" sixx.type="SmallInteger" >20</sixx.object>
	<sixx.object sixx.id="3" sixx.name="instVar3" sixx.type="SmallInteger" >30</sixx.object>
</sixx.object>
'.
	SixxMockClassForUnitTest
		instVar1: 0;
		instVar2: 0;
		instVar3: 0.
	self should: [SixxMockClassForUnitTest instVar1 = 0].
	self should: [SixxMockClassForUnitTest instVar2 = 0].
	self should: [SixxMockClassForUnitTest instVar3 = 0].
	Object readSixxFrom: sixxString.
	self should: [SixxMockClassForUnitTest instVar1 = 10].
	self should: [SixxMockClassForUnitTest instVar2 = 20].
	self should: [SixxMockClassForUnitTest instVar3 = 30]!

testReadSixxForColor
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Color" >(Color r: 0.0 g: 0.0 b: 1.0)</sixx.object>
'.
	self should: [(Object readSixxFrom: sixxString) = Color blue asRGB	"Dolphin Specific"]!

testReadSixxForCompositeObject
	| sixxString slipObj headerObj |
	sixxString := '<sixx.object sixx.id="0" sixx.type="SixxMockEnvelope" >
	<sixx.object sixx.id="1" sixx.name="header" sixx.type="SixxMockHeader" >
		<sixx.object sixx.id="2" sixx.name="id" sixx.type="String" >99</sixx.object>
	</sixx.object>
</sixx.object>
'.
	slipObj := Object readSixxFrom: sixxString.
	headerObj := slipObj header.
	self should: [headerObj id = '99']!

testReadSixxForCorruptRecursiveDictionary
	"SixxLoadingTestCase debug: #testReadSixxForCorruptRecursiveDictionary"

	| originalRecoveryRead |

	[| sixxString |
	originalRecoveryRead := SixxSetting useRecoveryRead.
	SixxSetting useRecoveryRead: false.
	sixxString := '<sixx.object sixx.id="0" sixx.type="Dictionary" >
	<sixx.object sixx.id="1" sixx.type="Association" >
		<sixx.object sixx.id="2" sixx.name="key" sixx.type="Symbol" >key2</sixx.object>
		<sixx.object sixx.id="3" sixx.name="value" sixx.type="SmallInteger" >100</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.type="Association" >
		<sixx.object sixx.id="5" sixx.name="key" sixx.type="Symbol" >key1</sixx.object>
		<sixx.object sixx.id="6" sixx.name="value" sixx.type="String" >value1</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="7" sixx.type="Association" >
		<sixx.object six
'.

	self should: [Object readSixxFrom: sixxString] raise: SixxXmlParseError] 
			ensure: [SixxSetting useRecoveryRead: originalRecoveryRead]!

testReadSixxForDate
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Date" >14 May 2002</sixx.object>
'.
	self should: 
			[(Object readSixxFrom: sixxString) = (Date 
						newDay: 14
						monthIndex: 5
						year: 2002)]!

testReadSixxForDictionary
	| sixxString dic |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Dictionary" >
	<sixx.object sixx.id="1" sixx.type="Association" >
		<sixx.object sixx.id="2" sixx.name="key" sixx.type="Symbol" >key2</sixx.object>
		<sixx.object sixx.id="3" sixx.name="value" sixx.type="SmallInteger" >100</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.type="Association" >
		<sixx.object sixx.id="5" sixx.name="key" sixx.type="Symbol" >key1</sixx.object>
		<sixx.object sixx.id="6" sixx.name="value" sixx.type="String" >value1</sixx.object>
	</sixx.object>
</sixx.object>
'.
	dic := Object readSixxFrom: sixxString.
	self should: [dic size = 2].
	self should: [(dic at: #key1) = 'value1'].
	self should: [(dic at: #key2) = 100]!

testReadSixxForIndexedColor
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="IndexedColor" >(IndexedColor stdColor: #red)</sixx.object>
'.
	self should: [(Object readSixxFrom: sixxString) = IndexedColor red]!

testReadSixxForInterval
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Interval" >(1 to: 10 by: 3)</sixx.object>
'.
	self should: [(Object readSixxFrom: sixxString) = (1 to: 10 by: 3)]!

testReadSixxForPoint
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Point" >1@3</sixx.object>
'.
	self should: [(Object readSixxFrom: sixxString) = (1 @ 3)].
	sixxString := '<sixx.object sixx.id="0" sixx.type="Point" >123456789.0@-3.5</sixx.object>
'.
	self should: [(Object readSixxFrom: sixxString) = (123456789.0 @ -3.5)]!

testReadSixxForRecursiveArray
	| sixxString arr |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Array" >
	<sixx.object sixx.id="1" sixx.type="SmallInteger" >10</sixx.object>
	<sixx.object sixx.id="2" sixx.type="SmallInteger" >20</sixx.object>
	<sixx.object sixx.idref="0" ></sixx.object>
</sixx.object>
'.
	arr := Object readSixxFrom: sixxString.
	self should: [arr size = 3].
	self should: [(arr at: 1) = 10].
	self should: [(arr at: 2) = 20].
	self should: [(arr at: 3) == arr]!

testReadSixxForRecursiveDictionary
	| sixxString dic |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Dictionary" >
	<sixx.object sixx.id="1" sixx.type="Association" >
		<sixx.object sixx.id="2" sixx.name="key" sixx.type="Symbol" >key2</sixx.object>
		<sixx.object sixx.id="3" sixx.name="value" sixx.type="SmallInteger" >100</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.type="Association" >
		<sixx.object sixx.id="5" sixx.name="key" sixx.type="Symbol" >key1</sixx.object>
		<sixx.object sixx.id="6" sixx.name="value" sixx.type="String" >value1</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="7" sixx.type="Association" >
		<sixx.object sixx.id="8" sixx.name="key" sixx.type="Symbol" >key3</sixx.object>
		<sixx.object sixx.idref="0" sixx.name="value" ></sixx.object>
	</sixx.object>
</sixx.object>
'.
	dic := Object readSixxFrom: sixxString.
	self should: [dic size = 3].
	self should: [(dic at: #key1) = 'value1'].
	self should: [(dic at: #key2) = 100].
	self should: [(dic at: #key3) == dic]!

testReadSixxForRGB
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="RGB" >16711680</sixx.object>
'.
	self should: [(Object readSixxFrom: sixxString) = RGB blue]!

testReadSixxForRunArray
	| sixxString runArray |
	sixxString := '<sixx.object sixx.id="0" sixx.type="RunArray" >
	<sixx.object sixx.id="1" sixx.name="runs" sixx.type="Array" >
		<sixx.object sixx.id="2" sixx.type="SmallInteger" >1</sixx.object>
		<sixx.object sixx.id="3" sixx.type="SmallInteger" >2</sixx.object>
		<sixx.object sixx.idref="2" ></sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.name="values" sixx.type="Array" >
		<sixx.object sixx.idref="2" ></sixx.object>
		<sixx.object sixx.idref="3" ></sixx.object>
		<sixx.object sixx.id="5" sixx.type="SmallInteger" >3</sixx.object>
	</sixx.object>
</sixx.object>
'.
	runArray := Object readSixxFrom: sixxString.
	self should: [runArray runs = #(1 2 1)].
	self should: [runArray values = #(1 2 3)]!

testReadSixxForSimpleObject
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="SixxMockHeader" >
	<sixx.object sixx.id="1" sixx.name="id" sixx.type="String" >1000</sixx.object>
</sixx.object>
'.
	self should: [(Object readSixxFrom: sixxString) id = '1000']!

testReadSixxForStringUsingCDATA
	| originalSetting sixxString string |
	
	[originalSetting := SixxSetting useCDATA.
	SixxSetting useCDATA: true.
	sixxString := '<sixx.object sixx.id="0" sixx.type="String" ><!![CDATA[Hi, I''m String-object.
How are you?
]]></sixx.object>
'.
	string := Object readSixxFrom: sixxString.
	self should: [string = 'Hi, I''m String-object.
How are you?
']] 
			ensure: [SixxSetting useCDATA: originalSetting]!

testReadSixxForTime
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Time" >4:10:32 pm</sixx.object>
'.
	self should: 
			[(Object readSixxFrom: sixxString) 
				= (Time readSixxContentStringFrom: (ReadStream on: '4:10:32 pm'))]!

testReadSixxForUndefinedObject
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="UndefinedObject" >nil</sixx.object>
'.
	self should: [(Object readSixxFrom: sixxString) = nil]!

testReadSixxForVariableObject
	| sixxString variableObj |
	sixxString := '<sixx.object sixx.id="0" sixx.type="SixxMockBinaryData" >
	<sixx.object sixx.id="1" sixx.name="author" sixx.type="String" >MU</sixx.object>
	<sixx.object sixx.id="2" sixx.name="version" sixx.type="String" >0.1</sixx.object>
	<sixx.object sixx.id="3" sixx.type="SmallInteger" >1</sixx.object>
	<sixx.object sixx.id="4" sixx.type="SmallInteger" >2</sixx.object>
	<sixx.object sixx.id="5" sixx.type="SmallInteger" >3</sixx.object>
</sixx.object>
'.
	variableObj := Object readSixxFrom: sixxString.
	self should: [variableObj author = 'MU'].
	self should: [variableObj version = '0.1'].
	self should: [variableObj size = 3].
	self should: [(variableObj at: 1) = 1].
	self should: [(variableObj at: 2) = 2].
	self should: [(variableObj at: 3) = 3]!

testReadSixxForVariableObjectNoData
	
	| sixxString variableObj |
	sixxString := '<sixx.object sixx.id="0" sixx.type="SixxMockBinaryData" >
	<sixx.object sixx.id="1" sixx.name="author" sixx.type="String" >MU</sixx.object>
	<sixx.object sixx.id="2" sixx.name="version" sixx.type="String" >0.1</sixx.object>
</sixx.object>
'.
	variableObj := Object readSixxFrom: sixxString.
	self should: [ variableObj author = 'MU'].
	self should: [ variableObj version = '0.1'].
	self should: [ variableObj size = 0].

	
	!

testReadSixxWithClassDoesNotExist
	| str catched |
	str := '<sixx.object sixx.id="0" sixx.type="doesNotExistString" >abcde</sixx.object>
'.
	self should: [(Object readSixxFrom: str) = nil].
	catched := false.
	self should: 
			[[Object readSixxFrom: str] on: SixxClassNotFound do: [:ex | catched := true].
			catched]! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForArray!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForBag!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForBoolean!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForByteArray!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForCharacter!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForClass!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForColor!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForCompositeObject!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForCorruptRecursiveDictionary!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForDate!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForDictionary!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForIndexedColor!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForInterval!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForPoint!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForRecursiveArray!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForRecursiveDictionary!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForRGB!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForRunArray!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForSimpleObject!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForStringUsingCDATA!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForTime!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForUndefinedObject!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForVariableObject!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForVariableObjectNoData!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxWithClassDoesNotExist!public!tests! !

SixxNamespaceSupportTestCase guid: (GUID fromString: '{2EFC97CB-77B3-4C0B-A32C-F8D92D3C905E}')!
SixxNamespaceSupportTestCase comment: ''!
!SixxNamespaceSupportTestCase categoriesForClass!Unclassified! !
!SixxNamespaceSupportTestCase methodsFor!

setUp
	originalUseEnvironment := SixxSetting useEnvironment.
	SixxSetting useEnvironment: true!

tearDown
	SixxSetting useEnvironment: originalUseEnvironment!

testNamespacedArray
	"self debug: #testNamespacedArray"
	| arraySixx1 array1  arraySixx2 array2  |
	arraySixx1 :=  '<sixx.object sixx.id="0" sixx.type="Array" sixx.env="Core" >
	<sixx.object sixx.id="1" sixx.type="SmallInteger" sixx.env="Core" >10</sixx.object>
	<sixx.object sixx.id="2" sixx.type="SmallInteger" sixx.env="Core" >20</sixx.object>
</sixx.object>
'.
	array1 := Object readSixxFrom: arraySixx1.
	self should: [array1 = #(10 20)].
	
	arraySixx2 := array1 sixxString. 
	array2 := Object readSixxFrom: arraySixx2.
	self should: [array2 = #(10 20)]! !
!SixxNamespaceSupportTestCase categoriesFor: #setUp!public!running! !
!SixxNamespaceSupportTestCase categoriesFor: #tearDown!public!running! !
!SixxNamespaceSupportTestCase categoriesFor: #testNamespacedArray!public!tests! !

SixxNewFailedTestCase guid: (GUID fromString: '{9EE59691-5483-483C-9932-17DCC1FA4A05}')!
SixxNewFailedTestCase comment: ''!
!SixxNewFailedTestCase categoriesForClass!SUnit! !
!SixxNewFailedTestCase methodsFor!

testWriteReadNewFailedClass
	| original sixxString read |
	original := SixxMockFixedNewFailedClass prototype1.
	self should: [original att1 = 1].
	self should: [original att2 = 'TWO'].
	self should: [original sixxString] raise: SixxInvalidSerialization.
	sixxString := original sixxString.
	self should: [Object readSixxFrom: sixxString] raise: SixxNewFailed.
	read := Object readSixxFrom: sixxString.
	self should: [read att1 = 1].
	self should: [read att2 = 'TWO'].
	self should: [read att3Block notNil]!

testWriteReadNewFailedClassReciverAlternative
	| original sixxString read |
	original := SixxMockFixedNewFailedClass prototype1.
	self should: [original att1 = 1].
	self should: [original att2 = 'TWO'].
	self should: [original sixxString] raise: SixxInvalidSerialization.
	sixxString := original sixxString.
	self should: [Object readSixxFrom: sixxString] raise: SixxNewFailed.
	read := [Object readSixxFrom: sixxString] on: SixxNewFailed
				do: [:ex | ex resume: SixxMockFixedAlternativeClass].
	self should: [read class = SixxMockFixedAlternativeClass].
	self should: [read att1 = 1].
	self should: [read att2 = 'TWO'].
	self should: [read att3Block notNil]!

testWriteReadNewVariableFailedClass
	| original sixxString read |
	original := SixxMockVariableNewFailedClass prototype1.
	self should: [original att1 = 1].
	self should: [original att2 = 'TWO'].
	self should: [original sixxString] raise: SixxInvalidSerialization.
	sixxString := original sixxString.
	self should: [Object readSixxFrom: sixxString] raise: SixxNewFailed.
	read := Object readSixxFrom: sixxString.
	self should: [read att1 = 1].
	self should: [read att2 = 'TWO'].
	self should: [read att3Block notNil]!

testWriteReadNewVariableFailedClassReciverAlternative
	| original sixxString read |
	original := SixxMockVariableNewFailedClass prototype1.
	self should: [original att1 = 1].
	self should: [original att2 = 'TWO'].
	self should: [original sixxString] raise: SixxInvalidSerialization.
	sixxString := original sixxString.
	self should: [Object readSixxFrom: sixxString] raise: SixxNewFailed.
	read := [Object readSixxFrom: sixxString] on: SixxNewFailed
				do: [:ex | ex resume: SixxMockVariableAlternativeClass].
	self should: [read class = SixxMockVariableAlternativeClass].
	self should: [read att1 = 1].
	self should: [read att2 = 'TWO'].
	self should: [read att3Block notNil]! !
!SixxNewFailedTestCase categoriesFor: #testWriteReadNewFailedClass!public!tests! !
!SixxNewFailedTestCase categoriesFor: #testWriteReadNewFailedClassReciverAlternative!public!tests! !
!SixxNewFailedTestCase categoriesFor: #testWriteReadNewVariableFailedClass!public!tests! !
!SixxNewFailedTestCase categoriesFor: #testWriteReadNewVariableFailedClassReciverAlternative!public!tests! !

SixxReadStreamTestCase guid: (GUID fromString: '{52E390D4-E836-4864-B0D6-303D3FB709F4}')!
SixxReadStreamTestCase comment: ''!
!SixxReadStreamTestCase categoriesForClass!SUnit! !
!SixxReadStreamTestCase methodsFor!

testAtEnd
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: (ReadStream on: str).
	self should: [stream next = 'a' and: [stream atEnd not]].
	self should: [stream next = 'b' and: [stream atEnd not]].
	self should: [stream next = 'c' and: [stream atEnd]].
	self should: [stream next = nil and: [stream atEnd]]!

testCachedObjects
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: (ReadStream on: str).
	stream
		next;
		next.
	self should: [(stream cachedObjects at: 1) = 'a'].
	self should: [(stream cachedObjects at: 2) = 'b'].
	self shouldnt: [stream cachedObjects includesKey: 3].
	stream next.
	self should: [(stream cachedObjects at: 3) = 'c']!

testNext
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: (ReadStream on: str).
	self should: [stream next = 'a'].
	self should: [stream next = 'b'].
	self should: [stream next = 'c'].
	self should: [stream next = nil]!

testNextMany
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: (ReadStream on: str).
	self should: [(stream next: 2) = (OrderedCollection with: 'a' with: 'b')].
	stream reset.
	self should: 
			[(stream next: 5) = (OrderedCollection 
						with: 'a'
						with: 'b'
						with: 'c')]!

testNextWithIdred
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="Character" >$a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="Character" >$u</sixx.object>
	<sixx.object sixx.idref="0" ></sixx.object>
	<sixx.object sixx.idref="1" ></sixx.object>
</sixx>'.
	stream := SixxReadStream on: (ReadStream on: str).
	self should: [stream next = $a].
	self should: [stream next = $u].
	self should: [stream next = $a].
	self should: [stream next = $u]!

testPeek
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: (ReadStream on: str).
	self should: [stream position = 0].
	self should: [stream peek = 'a'].
	self should: [stream position = 0].
	self should: [stream next = 'a']!

testPosition
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: (ReadStream on: str).
	stream next: 3.
	self should: [stream position = 3].
	stream position: 1.
	self should: [stream next = 'b']!

testReadEmptyStream
	| stream empStream |
	empStream := '' readStream.
	self	should: [empStream size = 0].
	stream :=  SixxReadStream on: empStream.
	
	self	should: [stream position = 0].
	self	should: [stream atEnd].
	self	should: [stream next isNil].!

testReadNextContainsIdref
	| str stream firstObj secondObj thirdObj |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="Array" >
		<sixx.object sixx.id="1" sixx.type="SmallInteger" >10</sixx.object>
		<sixx.object sixx.id="2" sixx.type="SmallInteger" >20</sixx.object>
		<sixx.object sixx.id="3" sixx.type="SmallInteger" >30</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.type="OrderedCollection" >
		<sixx.object sixx.idref="0" ></sixx.object>
	</sixx.object>
	<sixx.object sixx.id="5" sixx.type="Array" >
		<sixx.object sixx.idref="1" ></sixx.object>
		<sixx.object sixx.idref="2" ></sixx.object>
		<sixx.object sixx.idref="3" ></sixx.object>
	</sixx.object>
</sixx>'.
	stream := SixxReadStream on: (ReadStream on: str).
	self should: [stream size = 3].
	firstObj := stream next.
	secondObj := stream next.
	thirdObj := stream next.
	self should: [firstObj = #(10 20 30)].
	self should: [(secondObj at: 1) == firstObj].
	self should: [thirdObj = #(10 20 30) and: [thirdObj ~~ firstObj]]!

testRecoveryRead
	| originalRecoveryRead |

	[| str stream nextObject |
	originalRecoveryRead := SixxSetting useRecoveryRead.

	SixxSetting useRecoveryRead: true.

	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="Dictionary" >
	<sixx.object sixx.id="1" sixx.type="Association" >
		<sixx.object sixx.id="2" sixx.name="key" sixx.type="Symbol" >key2</sixx.object>
		<sixx.object sixx.id="3" sixx.name="value" sixx.type="SmallInteger" >100</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.type="Association" >
		<sixx.object sixx.id="5" sixx.name="key" sixx.type="Symbol" >key1</sixx.object>
		<sixx.object sixx.id="6" sixx.name="value" sixx.type="String" >value1</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="7" sixx.type="Association" >
		<sixx.object six
'.

	stream := SixxReadStream on: (ReadStream on: str).
	self shouldnt: [nextObject := stream next] raise: Error.
	self should: [nextObject class = Dictionary].
	self should: [(nextObject at: #key1) = 'value1'].
	self should: [(nextObject at: #key2) = 100].
	self shouldnt: [nextObject includesKey: #key3]] 
			ensure: [SixxSetting useRecoveryRead: originalRecoveryRead]!

testReset
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: (ReadStream on: str).
	[stream atEnd] whileFalse: [stream next].
	self should: [stream next = nil].
	stream reset.
	self should: [stream position = 0]!

testSize
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: (ReadStream on: str).
	self should: [stream size = 3]!

testSkip
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: (ReadStream on: str).
	self should: [stream position = 0].
	stream skip: 1.
	self should: [stream position = 1].
	stream next.
	self should: [stream position = 2].
	stream skip: 1.
	self should: [stream position = 3].
	stream skip: -1.
	self should: [stream position = 2].
	stream skip: 2.
	self should: [stream position = 3]! !
!SixxReadStreamTestCase categoriesFor: #testAtEnd!public!tests! !
!SixxReadStreamTestCase categoriesFor: #testCachedObjects!public!tests! !
!SixxReadStreamTestCase categoriesFor: #testNext!public!tests! !
!SixxReadStreamTestCase categoriesFor: #testNextMany!public!tests! !
!SixxReadStreamTestCase categoriesFor: #testNextWithIdred!public!tests! !
!SixxReadStreamTestCase categoriesFor: #testPeek!public!tests! !
!SixxReadStreamTestCase categoriesFor: #testPosition!public!tests! !
!SixxReadStreamTestCase categoriesFor: #testReadEmptyStream!public!tests! !
!SixxReadStreamTestCase categoriesFor: #testReadNextContainsIdref!public!tests! !
!SixxReadStreamTestCase categoriesFor: #testRecoveryRead!public!tests! !
!SixxReadStreamTestCase categoriesFor: #testReset!public!tests! !
!SixxReadStreamTestCase categoriesFor: #testSize!public!tests! !
!SixxReadStreamTestCase categoriesFor: #testSkip!public!tests! !

SixxWriteStreamTestCase guid: (GUID fromString: '{78B46238-085E-466E-89A8-B4292596987A}')!
SixxWriteStreamTestCase comment: ''!
!SixxWriteStreamTestCase categoriesForClass!SUnit! !
!SixxWriteStreamTestCase methodsFor!

testCloseTwice
	"SixxWriteStreamTestCase debug: #testCloseTwice"

	| st wst expected |
	expected := 
'<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >abc</sixx.object>
</sixx>'.
	st := WriteStream on: String new.
	wst := SixxWriteStream onWithDeclaration: st.
	wst nextPut: 'abc'.
	wst close.
	wst close.
	self should: [st contents = expected]!

testKeepStreamOpening
	"SixxWriteStreamTestCase debug: #testKeepStreamOpening"

	| st wst expected |
	expected := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >abc</sixx.object>
'.
	st := WriteStream on: String new.
	wst := SixxWriteStream onWithDeclaration: st.
	wst nextPut: 'abc'.
	self should: [st contents = expected]!

testNeverNextPutAndThenClose
	| st wst expected |
	expected := ''.
	st := WriteStream on: String new.
	wst := SixxWriteStream on: st.
	wst close.
	self should: [st contents = expected]!

testNextPut
	| st wst expected |
	expected := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >abc</sixx.object>
</sixx>'.
	st := WriteStream on: String new.
	wst := SixxWriteStream onWithDeclaration: st.
	wst nextPut: 'abc'.
	wst close.
	self should: [st contents = expected]!

testNextPutAll
	| st wst expected |
	expected := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="Character" >$a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="Character" >$b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="Character" >$c</sixx.object>
</sixx>'.
	st := WriteStream on: String new.
	wst := SixxWriteStream onWithDeclaration: st.
	wst nextPutAll: 'abc'.
	wst close.
	self should: [st contents = expected]!

testWriteRecursiveObject
	| st wst expected arr col |
	expected := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="Array" >
		<sixx.object sixx.id="1" sixx.type="SmallInteger" >10</sixx.object>
		<sixx.object sixx.id="2" sixx.type="SmallInteger" >20</sixx.object>
		<sixx.object sixx.id="3" sixx.type="SmallInteger" >30</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.type="OrderedCollection" >
		<sixx.object sixx.idref="0" ></sixx.object>
	</sixx.object>
	<sixx.object sixx.id="5" sixx.type="Array" >
		<sixx.object sixx.idref="1" ></sixx.object>
		<sixx.object sixx.idref="2" ></sixx.object>
		<sixx.object sixx.idref="3" ></sixx.object>
	</sixx.object>
</sixx>'.
	arr := #(10 20 30).
	col := OrderedCollection with: arr.
	st := WriteStream on: String new.
	wst := SixxWriteStream onWithDeclaration: st.
	wst nextPut: arr.
	wst nextPut: col.
	wst nextPut: #(10 20 30) copy.
	wst close.
	self should: [st contents = expected]! !
!SixxWriteStreamTestCase categoriesFor: #testCloseTwice!public!tests! !
!SixxWriteStreamTestCase categoriesFor: #testKeepStreamOpening!public!tests! !
!SixxWriteStreamTestCase categoriesFor: #testNeverNextPutAndThenClose!public!tests! !
!SixxWriteStreamTestCase categoriesFor: #testNextPut!public!tests! !
!SixxWriteStreamTestCase categoriesFor: #testNextPutAll!public!tests! !
!SixxWriteStreamTestCase categoriesFor: #testWriteRecursiveObject!public!tests! !

SixxXmlParserTestCase guid: (GUID fromString: '{1D781716-BB76-44E4-82AB-AFE8C8ED627C}')!
SixxXmlParserTestCase comment: ''!
!SixxXmlParserTestCase categoriesForClass!SUnit! !
!SixxXmlParserTestCase methodsFor!

testParseXmlWithSixxYaxoXmlParserAdapter
	"SixxXmlParserTestCase debug: #testParseXmlWithSixxYaxoXmlParserAdapter"

	| sixxString result oldParser |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Array" >
	<sixx.object sixx.id="1" sixx.type="SmallInteger" >100</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >abcde</sixx.object>
	<sixx.object sixx.id="3" sixx.type="Array" >
		<sixx.object sixx.id="4" sixx.type="SmallInteger" >10</sixx.object>
		<sixx.object sixx.id="5" sixx.type="SmallInteger" >20</sixx.object>
	</sixx.object>
	<sixx.object sixx.idref="0" ></sixx.object>
</sixx.object>
'.
	oldParser := SixxXmlUtil parserAdapter.
	
	[SixxXmlUtil parserAdapter: SixxYaxoXmlParserAdapter.
	result := Object readSixxFrom: sixxString.
	self should: [(result at: 1) = 100].
	self should: [(result at: 2) = 'abcde'].
	self should: [(result at: 3) = #(10 20)].
	self should: [(result at: 4) == result]] 
			ensure: [SixxXmlUtil parserAdapter: oldParser]! !
!SixxXmlParserTestCase categoriesFor: #testParseXmlWithSixxYaxoXmlParserAdapter!public!tests! !

"Binary Globals"!

"Resources"!

